/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxCriteri.cpp
//
// Descripci : Arxiu d'implementaci de la classe 
//				de gesti de criteris. 
//				Un criteri est composat per un atribut
//				vlid d'un objecte (rea, permetre, 
//				compacitat, ...), un oeprador de
//				comparaci i una expressi. Per exemple, 
//				area < 12 + perimetre - 35 * 4
//				s un criteri.
//				Els criteris sn emprats en l'identificaci
//				d'objectes, ja que un objecte concret
//				ha de complir una srie de criteris per tal
//				de caure dins d'una classe concreta.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"
#include "AuxCriteri.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// El constructor
CAuxCriteri::CAuxCriteri()
{
	m_atribut=atNul;
	m_comparacio=cmIgual;
}

//
// Destructor. En primer lloc, allibera la memria de tots
// els elements de l'expresi que formen part del criteri.
// A continuaci, borra l'array en si.
//
CAuxCriteri::~CAuxCriteri()
{
	int i;
	for (i=0;i<m_expressio.GetSize();i++)
		if (m_expressio[i]!=NULL) {
				delete m_expressio[i];
		}
	m_expressio.RemoveAll();
}

CAuxCriteri::CAuxCriteri(enum TAtribut at, enum TComparacio cmp)
{
	m_atribut=at;
	m_comparacio=cmp;
}

CLlistaElementsExpressio * CAuxCriteri::obtenirExpressio()
{
	return &m_expressio;
}

enum TAtribut CAuxCriteri::obtenirAtribut()
{
	return m_atribut;
}

enum TComparacio CAuxCriteri::obtenirComparacio()
{
	return m_comparacio;
}

void CAuxCriteri::posarAtribut(enum TAtribut at)
{
	m_atribut=at;
}

void CAuxCriteri::posarComparacio(enum TComparacio c)
{
	m_comparacio=c;
}
