/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxCriteri.h
//
// Descripci : Arxiu de capalera de la classe 
//				de gesti de criteris. 
//				Un criteri est composat per un atribut
//				vlid d'un objecte (rea, permetre, 
//				compacitat, ...), un operador de
//				comparaci i una expressi. Per exemple, 
//				area < 12 + perimetre - 35 * 4
//				s un criteri.
//				Els criteris sn emprats en l'identificaci
//				d'objectes, ja que un objecte concret
//				ha de complir una srie de criteris per tal
//				de caure dins d'una classe.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_CRITERI_H__734C61D4_F04E_11D3_B5D7_00C026C084F2__INCLUDED_)
#define AFX_CRITERI_H__734C61D4_F04E_11D3_B5D7_00C026C084F2__INCLUDED_

//
// Arxius de capalera
//
#include "AuxElementExpressio.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

enum TComparacio {cmMajor, cmMenor, cmIgual, cmDistint, cmMajorIgual, cmMenorIgual, cmNul};

class CAuxCriteri  
{
public:
	// Constructors
	CAuxCriteri(enum TAtribut at, enum TComparacio cmp);
	CAuxCriteri();
	// Funcions d'accs a les dades de l'objecte.
	void posarComparacio(enum TComparacio c);
	void posarAtribut (enum TAtribut at);
	enum TComparacio obtenirComparacio();
	enum TAtribut obtenirAtribut();
	CLlistaElementsExpressio * obtenirExpressio();
	// Destructor
	virtual ~CAuxCriteri();

private:
	// Les dades de l'objecte.
	enum TAtribut m_atribut;
	enum TComparacio m_comparacio;
	CLlistaElementsExpressio m_expressio;
};

// La classe CLlistaCriteris s'implementa a partir de la
// plantilla de les MFC CArray.
// CLlistaCriteris s, simplement, una llista de criteris. 
typedef CArray<CAuxCriteri *, CAuxCriteri *> CLlistaCriteris;

#endif // !defined(AFX_CRITERI_H__734C61D4_F04E_11D3_B5D7_00C026C084F2__INCLUDED_)
