/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxElementExpressio.h
//
// Descripci : Una llista d'aquests elements configura una 
//				expressi. Un element expressi pot estar 
//				composat per un atribut vlid d'un objecte 
//				(area, perimetre, ...) o un valor numric, 
//				i una operaci (suma, resta, ...). L'element 
//				es llegeix 'operacio valor'.
//				Operacio pot ser'opInici' per marcar inici 
//				d'expressi.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"
#include "AuxElementExpressio.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CAuxElementExpressio::CAuxElementExpressio(bool esvalor, double valor, enum TAtribut atribut, enum TOperacio operacio)
{
	m_esValor=esvalor;
	m_valor=valor;
	m_atribut=atribut;
	m_operacio=operacio;
}

CAuxElementExpressio::~CAuxElementExpressio()
{

}

bool CAuxElementExpressio::esValor()
{
	return m_esValor;
}

double CAuxElementExpressio::obtenirValor()
{
	if (m_esValor)
		return m_valor;
	else
		return 0.0;
}

enum TAtribut CAuxElementExpressio::obtenirAtribut()
{
	if (!m_esValor)
		return m_atribut;
	else
		return atNul;
}

CAuxElementExpressio::CAuxElementExpressio()
{
	m_atribut=atNul;
	m_esValor=true;
	m_operacio=opInici;
	m_valor=0.0;
}

void CAuxElementExpressio::posarAtribut(TAtribut at)
{
	m_atribut=at;
}

void CAuxElementExpressio::posarValor(double v)
{
	m_valor=v;
}

void CAuxElementExpressio::valor(bool v)
{
	m_esValor=v;
}

TOperacio CAuxElementExpressio::obtenirOperacio()
{
	return m_operacio;
}

void CAuxElementExpressio::posarOperacio(TOperacio op)
{
	m_operacio=op;
}
