/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxElementExpressio.h
//
// Descripci : Una llista d'aquests elements configura una 
//				expressi. Un element expressi pot estar 
//				composat per un atribut vlid d'un objecte 
//				(area, perimetre, ...) o un valor numric, 
//				i una operaci (suma, resta, ...). L'element 
//				es llegeix 'operacio valor'.
//				Operacio pot ser'opInici' per marcar inici 
//				d'expressi.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_ELEMENTEXPRESSIO_H__734C61D3_F04E_11D3_B5D7_00C026C084F2__INCLUDED_)
#define AFX_ELEMENTEXPRESSIO_H__734C61D3_F04E_11D3_B5D7_00C026C084F2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

enum TOperacio {opSuma, opResta, opProducte, opDivisio, opInici};
enum TAtribut {atArea, atPerimetre, atDMin, atDMax, atCompacitat, atNul};

class CAuxElementExpressio  
{
public:
	void posarOperacio(TOperacio op);
	TOperacio obtenirOperacio();
	void valor(bool v);
	void posarValor(double v);
	void posarAtribut(TAtribut at);
	 CAuxElementExpressio();
	enum TAtribut obtenirAtribut();
	double obtenirValor();
	bool esValor();
	CAuxElementExpressio(bool esvalor, double valor, enum TAtribut atribut, enum TOperacio operacio);
	virtual ~CAuxElementExpressio();

private:
	double m_valor;
	enum TAtribut m_atribut;
	bool m_esValor;
	enum TOperacio m_operacio;
};

typedef CArray<CAuxElementExpressio *, CAuxElementExpressio *> CLlistaElementsExpressio;

#endif // !defined(AFX_ELEMENTEXPRESSIO_H__734C61D3_F04E_11D3_B5D7_00C026C084F2__INCLUDED_)
