/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxLlistaEquivalencia.cpp
//
// Descripci : La llista d'equivalncia s'empra en l'anlisi de
//				connectivitat.
//				La seva funci s gestionar la informaci referent
//				a quins pixels de la imatge pertanyen a un
//				mateix objecte.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"
#include "AuxLlistaEquivalencia.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CAuxLlistaEquivalencia::CAuxLlistaEquivalencia()
{
	laLlista.SetSize(0, 10);
}

CAuxLlistaEquivalencia::~CAuxLlistaEquivalencia()
{
	laLlista.RemoveAll();
	laLlista.FreeExtra();
}

void CAuxLlistaEquivalencia::posarValor(int posicio, int valor)
{
	laLlista.SetAtGrow(posicio, valor);
}

int CAuxLlistaEquivalencia::obtenirValor(int posicio)
{
	if (posicio>laLlista.GetSize()-1) return posicio;
	else return laLlista.GetAt(posicio);
}

int CAuxLlistaEquivalencia::obtenirDarreraMarca(int pos)
{
	if (pos==laLlista.GetAt(pos)) return pos;
	else return (obtenirDarreraMarca(laLlista.GetAt(pos)));
}

int CAuxLlistaEquivalencia::omplirLlista(int marca)
{
	int equ;

	equ=laLlista.GetAt(marca);
	if (equ==laLlista.GetAt(equ)) return equ;
	else return (laLlista[equ]=omplirLlista(equ));
}

int CAuxLlistaEquivalencia::ferLlistaIncremental()
{
	int i, j, vell, nou, max=0;

	nou=-1;
	for (i=1;i<laLlista.GetSize();i++) {
		vell=laLlista[i];
		if (vell>=0) {
			for (j=i;j<laLlista.GetSize();j++) 
				if (laLlista[j]==vell) laLlista[j]=nou;
			nou--;
		}
	}

	for (i=1;i<laLlista.GetSize();i++) {
		laLlista[i]=abs(laLlista[i]);
		if (laLlista[i]>max) max=laLlista[i];
	}

	return max;
}

int CAuxLlistaEquivalencia::arreglarLlista()
{
	int i;

	for (i=1;i<laLlista.GetSize();i++)
		laLlista[i]=omplirLlista(i);

	return (ferLlistaIncremental());
}
