/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxObjecte.cpp
//
// Descripci : Cont informaci sobre un objecte genric: criteris 
//				que el defineixen i forma d'agafada.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BRAS.h"
#include "AuxObjecte.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CAuxObjecte::CAuxObjecte()
{
	m_DX=0.0;
	m_DY=0.0;
	m_nom=_T("");
	m_R=0.0;
}

CAuxObjecte::~CAuxObjecte()
{
//	int i;
//	for (i=0;i<m_criteris.GetSize();i++) 
//		if (m_criteris[i]!=NULL) delete m_criteris[i];
	m_criteris.RemoveAll();
}

double CAuxObjecte::obtenirRotacioAgafada()
{
	return m_R;
}

double CAuxObjecte::obtenirDespXAgafada()
{
	return m_DX;
}

double CAuxObjecte::obtenirDespYAgafada()
{
	return m_DY;
}

CLlistaCriteris * CAuxObjecte::obtenirCriteris()
{
	return &m_criteris;
}

void CAuxObjecte::posarRotacioAgafada(double r)
{
	m_R = r;
}

void CAuxObjecte::posarDespXAgafada(double dx)
{
	m_DX=dx;
}

void CAuxObjecte::posarDespYAgafada(double dy)
{
	m_DY=dy;
}

CString CAuxObjecte::obtenirNom()
{
	return m_nom;
}

void CAuxObjecte::posarNom(CString nom)
{
	m_nom=nom;
}

CAuxObjecte::CAuxObjecte(CString nom, double DX, double DY, double R)
{
	m_nom=nom;
	m_DX=DX;
	m_DY=DY;
	m_R=R;
}
