/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxObjecte.h
//
// Descripci : Cont informaci sobre un objecte genric: criteris 
//				que el defineixen i forma d'agafada.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_OBJECTE_H__734C61D5_F04E_11D3_B5D7_00C026C084F2__INCLUDED_)
#define AFX_OBJECTE_H__734C61D5_F04E_11D3_B5D7_00C026C084F2__INCLUDED_

#include "AuxCriteri.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CAuxObjecte  
{
public:
	CAuxObjecte (CString nom, double DX, double DY, double R);
	void posarNom(CString nom);
	CString obtenirNom();
	void posarDespYAgafada(double dy);
	void posarDespXAgafada(double dx);
	void posarRotacioAgafada(double r);
	CLlistaCriteris * obtenirCriteris();
	double obtenirDespYAgafada();
	double obtenirDespXAgafada();
	double obtenirRotacioAgafada();
	CAuxObjecte();
	virtual ~CAuxObjecte();

private:
	double m_R;
	double m_DY;
	double m_DX;
	CString m_nom;
	CLlistaCriteris m_criteris;
};

typedef CArray<CAuxObjecte *, CAuxObjecte *> CLlistaObjectes;
// Nota : Sn punters a objecte, per tant en voler buidar aquesta
// llista, primer s'ha de recrrer tota i anar fent deletes, i
// desprs cridar al RemoveAll() de CArray.

#endif // !defined(AFX_OBJECTE_H__734C61D5_F04E_11D3_B5D7_00C026C084F2__INCLUDED_)
