/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxObjecteGenerat.cpp
//
// Descripci : Cont informaci sobre un objecte generat. 
//				Es una versi restringida de CAuxObjecte en que
//				els criteris no sn una expressi qualsevol, 
//				sino 'atribut < valor1 i atribut > valor2'.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BRAS.h"
#include "AuxObjecteGenerat.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CAuxObjecteGenerat::CAuxObjecteGenerat()
{
	m_DX=0;
	m_DY=0;
	m_Rot=0;
}

CAuxObjecteGenerat::~CAuxObjecteGenerat()
{

}

void CAuxObjecteGenerat::posarNom(CString nom)
{
	m_nom=nom;
}

void CAuxObjecteGenerat::posarDmMin(int d)
{
	m_dmMin=d;
}

void CAuxObjecteGenerat::posarDmMax(int d)
{
	m_dmMax=d;
}

void CAuxObjecteGenerat::posarDMMin(int d)
{
	m_dMMin=d;
}

void CAuxObjecteGenerat::posarDMMax(int d)
{
	m_dMMax=d;
}

void CAuxObjecteGenerat::posarAMax(long int a)
{
	m_aMax=a;
}

void CAuxObjecteGenerat::posarAMin(long int a)
{
	m_aMin=a;
}

void CAuxObjecteGenerat::posarPMax(int p)
{
	m_pMax=p;
}

void CAuxObjecteGenerat::posarPMin(int p)
{
	m_pMin=p;
}

void CAuxObjecteGenerat::posarCMax(double c)
{
	m_cMax=c;
}

void CAuxObjecteGenerat::posarCMin(double c)
{
	m_cMin=c;
}

CString CAuxObjecteGenerat::obtenirNom()
{
	return m_nom;
}

long int CAuxObjecteGenerat::obtenirAMin()
{
	return m_aMin;
}

long int CAuxObjecteGenerat::obtenirAMax()
{
	return m_aMax;
}

int CAuxObjecteGenerat::obtenirPMin()
{
	return m_pMin;
}

int CAuxObjecteGenerat::obtenirPMax()
{
	return m_pMax;
}

double CAuxObjecteGenerat::obtenirCMin()
{
	return m_cMin;
}

double CAuxObjecteGenerat::obtenirCMax()
{
	return m_cMax;
}

int CAuxObjecteGenerat::obtenirDmMin()
{
	return m_dmMin;
}

int CAuxObjecteGenerat::obtenirDmMax()
{
	return m_dmMax;
}

int CAuxObjecteGenerat::obtenirDMMin()
{
	return m_dMMin;
}

int CAuxObjecteGenerat::obtenirDMMax()
{
	return m_dMMax;
}

CAuxObjecteGenerat::CAuxObjecteGenerat(CString nom, long int amin, long int amax, int pmin, int pmax, double cmin, double cmax, int dminmin, int dminmax, int dmaxmin, int dmaxmax, double dmaxminmin, double dmaxminmax)
{
	m_nom=nom;
	m_aMin=amin;
	m_aMax=amax;
	m_pMin=pmin;
	m_pMax=pmax;
	m_cMin=cmin;
	m_cMax=cmax;
	m_dmMin=dminmin;
	m_dmMax=dminmax;
	m_dMMin=dmaxmin;
	m_dMMax=dmaxmax;
	m_dMaxMinMax=dmaxminmax;
	m_dMaxMinMin=dmaxminmin;
	m_DX=0;
	m_DY=0;
	m_Rot=0;
}

double CAuxObjecteGenerat::obtenirDMaxMinMin()
{
	return m_dMaxMinMin;
}

double CAuxObjecteGenerat::obtenirDMaxMinMax()
{
	return m_dMaxMinMax;
}

void CAuxObjecteGenerat::posarDMaxMinMin(double d)
{
	m_dMaxMinMin=d;
}

void CAuxObjecteGenerat::posarDMaxMinMax(double d)
{
	m_dMaxMinMax=d;
}

double CAuxObjecteGenerat::obtenirDX()
{
	return m_DX;
}

double CAuxObjecteGenerat::obtenirDY()
{
	return m_DY;
}

double CAuxObjecteGenerat::obtenirRot()
{
	return m_Rot;
}

void CAuxObjecteGenerat::posarDX(double d)
{
	m_DX=d;
}

void CAuxObjecteGenerat::posarDY(double d)
{
	m_DY=d;
}

void CAuxObjecteGenerat::posarRotacio(double rot)
{
	m_Rot=rot;
}
