/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxObjecteGenerat.h
//
// Descripci : Cont informaci sobre un objecte generat. 
//				Es una versi restringida de CAuxObjecte en que
//				els criteris no sn una expressi qualsevol, 
//				sino 'atribut < valor1 i atribut > valor2'.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_OBJECTEGENERAT_H__E9638262_0A20_11D4_B60D_00C026C084F2__INCLUDED_)
#define AFX_OBJECTEGENERAT_H__E9638262_0A20_11D4_B60D_00C026C084F2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CAuxObjecteGenerat  
{
public:
	void posarRotacio(double rot);
	void posarDY(double d);
	void posarDX(double d);
	double obtenirRot();
	double obtenirDY();
	double obtenirDX();
	void posarDMaxMinMax(double d);
	double obtenirDMaxMinMax();
	double obtenirDMaxMinMin();
	CAuxObjecteGenerat(CString nom, long int amin, long int amax, int pmin, int pmax, double cmin, double cmax, int dminmin, int dminmax, int dmaxmin, int dmaxmax, double dmaxminmin, double dmaxminmax);
	int obtenirDMMax();
	int obtenirDMMin();
	int obtenirDmMax();
	int obtenirDmMin();
	double obtenirCMax();
	double obtenirCMin();
	int obtenirPMax();
	int obtenirPMin();
	long int obtenirAMax();
	long int obtenirAMin();
	CString obtenirNom();
	void posarCMin(double c);
	void posarCMax(double c);
	void posarPMin(int p);
	void posarPMax(int p);
	void posarAMin(long int a);
	void posarAMax(long int a);
	void posarDMMax(int d);
	void posarDMMin(int d);
	void posarDmMax(int d);
	void posarDmMin(int d);
	void posarNom(CString nom);
	void posarDMaxMinMin(double d);
	CAuxObjecteGenerat();
	virtual ~CAuxObjecteGenerat();

private:
	double m_DX;
	double m_DY;
	double m_Rot;
	double m_dMaxMinMax;
	double m_dMaxMinMin;
	int m_dmMax;
	int m_dmMin;
	int m_dMMin;
	int m_dMMax;
	long int m_aMin;
	long int m_aMax;
	int m_pMin;
	int m_pMax;
	double m_cMin;
	double m_cMax;
	CString m_nom;
};

typedef CArray<CAuxObjecteGenerat, CAuxObjecteGenerat> CLlistaObjectesGenerats;

#endif // !defined(AFX_OBJECTEGENERAT_H__E9638262_0A20_11D4_B60D_00C026C084F2__INCLUDED_)
