/////////////////////////////////////////////////////////////////
//
// Arxiu      : AuxToken.h
//
// Descripci : Els objectes CAuxToken contenen informaci sobre
//				un token, tant d'un programa bsc com d'un arxiu
//				de definici d'objectes (dob).
//				Contenen informaci de la cadena, del valor (en
//				cas que sigui numric), del token i del subtoken.			
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_TOKEN_H__4CA1FEC2_F00E_11D3_B5D6_00C026C084F2__INCLUDED_)
#define AFX_TOKEN_H__4CA1FEC2_F00E_11D3_B5D6_00C026C084F2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

enum TToken {tkIndefinit, tkId, tkObrirClau, tkTancarClau, tkFinal,
	tkAgafada, tkCriteris, tkDespRot, tkValor, tkAtribut, tkPuntiComa, 
	tkComparador, tkOperacio, tkDX, tkDY, tkR, tkArea, tkPerimetre,
	tkDMin, tkDMax, tkCompacitat, tkMajor, tkMenor, tkIgual, 
	tkDistint, tkMajorIgual, tkMenorIgual, tkSuma, tkResta, 
	tkProducte, tkDivisio, tkEtiqueta, tkGoto, tkDefinirEnRobot,
	tkAssignacio, tkTraslladar, tkExecutarEnRobot, tkFinalProg,
	tkObjecte, tkObrirParentesi, tkComa, tkTancarParentesi, tkSi,
	tkPuntRobot, tkEstat, tkGosub, tkReturn, tkObrir, tkMoure,
	tkTancar, tkMissatge, tkMostrarTemps, tkActivarCinta,
	tkDefinirFixeEnRobot, tkDesactivarCinta
};

class CAuxToken  
{
public:
	CAuxToken();
	void posarDades(enum TToken elToken, enum TToken elSubToken=tkIndefinit, CString laCadena=_T(""), double elValor=0.0);
	double obtenirValor();
	void posarValor(double nouValor);
	void posarSubToken (enum TToken nouSubToken);
	void posarToken (enum TToken nouToken);
	void posarCadena(CString novaCadena);
	CString obtenirCadena();
	enum TToken obtenirSubToken();
	enum TToken obtenirToken();
	CAuxToken(CString laCadena, enum TToken elToken, enum TToken elSubToken=tkIndefinit);
	virtual ~CAuxToken();

private:
	enum TToken m_subtoken;
	double m_valor;
	enum TToken m_token;
	CString m_cadena;
};

typedef CArray<CAuxToken, CAuxToken> CLlistaTokens;

#endif // !defined(AFX_TOKEN_H__4CA1FEC2_F00E_11D3_B5D6_00C026C084F2__INCLUDED_)
