/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgCfgCella.cpp
//
// Descripci : Arxiu d'implementaci de la classe que mant
//				i permet solicitar a l'usuari la configuraci
//				dels elements de la cel.la.
//				La solicitud de dades a l'usuari, aix com la
//				seva vosualitzaci es fan mitjanant un
//				quadre de dileg.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"
#include "DlgCfgCella.h"
#include "Sistema.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
// Constructor
//
CDlgCfgCella::CDlgCfgCella(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCfgCella::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCfgCella)
	m_nomArxiuObjectes = _T("");
	m_nomArxiuScript = _T("");
	m_xp1 = 0;
	m_xp2 = 0;
	m_xr1 = 0;
	m_xr2 = 0;
	m_yp1 = 0;
	m_yp2 = 0;
	m_yr1 = 0;
	m_yr2 = 0;
	m_tempsRefresc = 0;
	m_nMaxDeteccio = 0;
	m_nMaxInici = 0;
	m_tolerancia = 0;
	m_amplada = 0;
	m_vx = 0.0f;
	m_vy = 0.0f;
	m_xFinal = 0.0f;
	m_xInicial = 0.0f;
	m_yFinal = 0.0f;
	m_yInicial = 0.0f;
	m_temps = 0.0f;
	m_aturarCinta = FALSE;
	m_tempsAddicional = 0.0f;
	//}}AFX_DATA_INIT
}


void CDlgCfgCella::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCfgCella)
	DDX_Text(pDX, IDC_EDIT_ARXIU_OBJECTES, m_nomArxiuObjectes);
	DDX_Text(pDX, IDC_EDIT_ARXIU_SCRIPT, m_nomArxiuScript);
	DDX_Text(pDX, IDC_EDIT_XP1, m_xp1);
	DDX_Text(pDX, IDC_EDIT_XP2, m_xp2);
	DDX_Text(pDX, IDC_EDIT_XR1, m_xr1);
	DDX_Text(pDX, IDC_EDIT_XR2, m_xr2);
	DDX_Text(pDX, IDC_EDIT_YP1, m_yp1);
	DDX_Text(pDX, IDC_EDIT_YP2, m_yp2);
	DDX_Text(pDX, IDC_EDIT_YR1, m_yr1);
	DDX_Text(pDX, IDC_EDIT_YR2, m_yr2);
	DDX_Text(pDX, IDC_EDIT_REFRESC, m_tempsRefresc);
	DDX_Text(pDX, IDC_EDIT_DETECCIO, m_nMaxDeteccio);
	DDX_Text(pDX, IDC_EDIT_INICI, m_nMaxInici);
	DDX_Text(pDX, IDC_EDIT_TOLERANCIA, m_tolerancia);
	DDX_Text(pDX, IDC_EDIT_AMPLADA, m_amplada);
	DDX_Text(pDX, IDC_EDIT_VX, m_vx);
	DDX_Text(pDX, IDC_EDIT_VY, m_vy);
	DDX_Text(pDX, IDC_EDIT_XFINAL, m_xFinal);
	DDX_Text(pDX, IDC_EDIT_XINICIAL, m_xInicial);
	DDX_Text(pDX, IDC_EDIT_YFINAL, m_yFinal);
	DDX_Text(pDX, IDC_EDIT_YINICIAL, m_yInicial);
	DDX_Text(pDX, IDC_EDIT_TEMPS, m_temps);
	DDX_Check(pDX, IDC_CHECK_ATURARCINTA, m_aturarCinta);
	DDX_Text(pDX, IDC_EDIT_TADDICIONAL, m_tempsAddicional);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCfgCella, CDialog)
	//{{AFX_MSG_MAP(CDlgCfgCella)
	ON_BN_CLICKED(IDC_BOTO_CARREGAR, OnBotoCarregar)
	ON_BN_CLICKED(IDC_BOTO_RECARREGAR, OnBotoRecarregar)
	ON_BN_CLICKED(IDC_BOTO_SELEC_SCRIPT, OnBotoSelecScript)
	ON_BN_CLICKED(IDC_BOTO_EDITAR, OnBotoEditar)
	ON_BN_CLICKED(IDC_BOTO_EDITARSCRIPT, OnBotoEditarscript)
	ON_EN_CHANGE(IDC_EDIT_XINICIAL, OnChangeEditXinicial)
	ON_EN_CHANGE(IDC_EDIT_XFINAL, OnChangeEditXfinal)
	ON_EN_CHANGE(IDC_EDIT_TEMPS, OnChangeEditTemps)
	ON_EN_CHANGE(IDC_EDIT_YINICIAL, OnChangeEditYinicial)
	ON_EN_CHANGE(IDC_EDIT_YFINAL, OnChangeEditYfinal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//
// Aquesta funci es crida quan l'usuari pitja el bot de
// carregar arxius d'indetificaci d'objectes. 
// La implementaci solicita a l'usuari un arxiu i crida el
// mtode de crrega d'arxius de definici d'objectes de
// l'objecte d'identificaci global.
//
void CDlgCfgCella::OnBotoCarregar() 
{
	char directoriActual[250];
	static char BASED_CODE szFilter[] = "Arxius de definici d'objectes (*.dob)|*.dob|Tots els Arxius (*.*)|*.*||";
	CFileDialog fdlg(true, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	GetCurrentDirectory(200, directoriActual);
	if (fdlg.DoModal()==IDOK) {
		m_ident->carregarObjectes(fdlg.GetPathName());
		m_nomArxiuObjectes=fdlg.GetPathName();
		UpdateData(false);
	}
	SetCurrentDirectory(directoriActual);
}

//
// Inicialitza les dades de configuraci de la cel.la.
// En primer lloc dna uns valors per defecte. A
// continuaci intenta carregar els valors de disc.
// Si hi ha un arxiu guardat a disc, es carregaran
// aquestes dades. Si no, es mantendran els valors
// per defecte que s'han assignat abans.
// Tamb s'intenta carregar l'arxiu de definici d'objectes.
//
void CDlgCfgCella::inicialitzar(void *sistema)
{
	m_ident=&(((CSistema *)sistema)->m_identificacio);
	m_nomArxiu=((CSistema *)sistema)->m_arxiuConfiguracioCella;
	m_xr1 = 2733;
	m_yr1 = 1324;
	m_xr2 = 2292;
	m_yr2 = 3064;
	m_xp1 = 107;
	m_yp1 = 101;
	m_xp2 = 501;
	m_yp2 = 223;
	m_tempsRefresc=100;
	m_amplada=100;
	m_tolerancia=200;
	m_nMaxDeteccio=1;
	m_nMaxInici=4;
	m_tempsAddicional=1.5;
	m_aturarCinta=true;
	carregar();
	m_ident->carregarObjectes(m_nomArxiuObjectes);
}

//
// Realitza totes les tasques de finalitzaci de l'objecte, 
// entre elles, guardar-ne el contingut a disc.
//
void CDlgCfgCella::finalitzar()
{
	guardar();
}

//
// Carrega les dades des de disc.
// El nom de l'arxiu des d'on es carreguen les dades i a on
// es guarden est en la variable membre m_nomArxiu, el valor
// de la qual s'ha assignat durant la inicialitzaci.
//
void CDlgCfgCella::carregar()
{
	CFile fitxer;
	if (!fitxer.Open(m_nomArxiu, CFile::modeRead)) {
		AfxMessageBox ("Problemes llegint l'arxiu");
		return;
	}
	CArchive arxiu(&fitxer, CArchive::load);
	arxiu >> m_nomArxiuObjectes ;
	arxiu >> m_nomArxiuScript ;
	arxiu >> m_xr1;
	arxiu >> m_xr2;
	arxiu >> m_yr1;
	arxiu >> m_yr2;
	arxiu >> m_xp1;
	arxiu >> m_xp2;
	arxiu >> m_yp1;
	arxiu >> m_yp2;
	arxiu >> m_tempsRefresc;
	arxiu >> m_tolerancia;
	arxiu >> m_nMaxInici;
	arxiu >> m_nMaxDeteccio;
	arxiu >> m_amplada;
	arxiu >> m_xInicial;
	arxiu >> m_xFinal;
	arxiu >> m_yInicial ;
	arxiu >> m_yFinal;
	arxiu >> m_temps;
	arxiu >> m_vx;
	arxiu >> m_vy;
	arxiu >> m_aturarCinta;
	arxiu >> m_tempsAddicional;
	arxiu.Close();
	fitxer.Close();
}

//
// Guarda les dades des de disc.
// El nom de l'arxiu des d'on es carreguen les dades i a on
// es guarden est en la variable membre m_nomArxiu, el valor
// de la qual s'ha assignat durant la inicialitzaci.
//
void CDlgCfgCella::guardar()
{
	CFile fitxer;
	if (!fitxer.Open(m_nomArxiu, CFile::modeWrite | CFile::modeCreate)) {
		AfxMessageBox ("Problemes guardant l'arxiu");
		return;
	}
	CArchive arxiu(&fitxer, CArchive::store);

	arxiu << m_nomArxiuObjectes;
	arxiu << m_nomArxiuScript;
	arxiu << m_xr1;
	arxiu << m_xr2;
	arxiu << m_yr1;
	arxiu << m_yr2;
	arxiu << m_xp1;
	arxiu << m_xp2;
	arxiu << m_yp1;
	arxiu << m_yp2;
	arxiu << m_tempsRefresc;
	arxiu << m_tolerancia;
	arxiu << m_nMaxInici;
	arxiu << m_nMaxDeteccio;
	arxiu << m_amplada;
	arxiu << m_xInicial;
	arxiu << m_xFinal;
	arxiu << m_yInicial ;
	arxiu << m_yFinal;
	arxiu << m_temps;
	arxiu << m_vx;
	arxiu << m_vy;
	arxiu << m_aturarCinta;
	arxiu << m_tempsAddicional;
	arxiu.Close();
	fitxer.Close();
}

//
// Aquesta funci respon a l'event de pitjar el bot 
// de recarregar definici d'objectes en el quadre de
// dileg. El que fa s cridar a la funci membre de crrega
// de l'objecte d'identificaci.
// Aquesta funci s til per a tornar a carregar l'arxiu quan
// s'han fet modificacions a l'esmentat arxiu mentre el
// programa est en marxa.
//
void CDlgCfgCella::OnBotoRecarregar() 
{
	if (m_nomArxiuObjectes!=_T(""))
		m_ident->carregarObjectes(m_nomArxiuObjectes);	
}


//
// Funci que respon a l'event de pitjar el bot de selecci
// de script.
// Aquesta funci fa aparixer un quadre de dileg per a 
// seleccionar un arxiu de script. Simplement se'n guarda
// el nom complet i ruta per a emprar-lo quan l'usuari
// ho soliciti.
//
void CDlgCfgCella::OnBotoSelecScript() 
{
	char directoriActual[250];
	static char BASED_CODE szFilter[] = "Scripts d'actuaci de BRAS (*.bsc)|*.bsc|Tots els Arxius (*.*)|*.*||";
	CFileDialog fdlg(true, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	GetCurrentDirectory(200, directoriActual);
	if (fdlg.DoModal()==IDOK) {
		m_nomArxiuScript=fdlg.GetPathName();
		UpdateData(false);
	}
	SetCurrentDirectory(directoriActual);
}

//
// Resposta a l'event de pitjar el bot per a editar l'arxiu
// de definici d'objectes.
// Es crida un editor extern, concretament el Programmer's
// File Editor, programa freeware d'Allan Phillips.
//
void CDlgCfgCella::OnBotoEditar() 
{
	char directoriActual[250];
	GetCurrentDirectory(200, directoriActual);
	_spawnl(_P_NOWAIT, "executables/pfe32.exe", "executables/pfe32.exe", m_nomArxiuObjectes, NULL);
	SetCurrentDirectory(directoriActual);
}

//
// Resposta a l'event de pitjar el bot per a editar l'arxiu
// d'script.
// Es crida un editor extern, concretament el Programmer's
// File Editor, programa freeware d'Allan Phillips.
//
void CDlgCfgCella::OnBotoEditarscript() 
{
	char directoriActual[250];
	GetCurrentDirectory(200, directoriActual);
	_spawnl(_P_NOWAIT, "executables/pfe32.exe", "executables/pfe32.exe", m_nomArxiuScript, NULL);
	SetCurrentDirectory(directoriActual);
}

//
// Funci que recalcula el valor del vector velocitat de la cinta
// a partir de les posicions inicial i final i del temps.
//
void CDlgCfgCella::actualitzaVelocitat()
{
	UpdateData(true);
	m_vx=(m_xFinal-m_xInicial)/m_temps;
	m_vy=(m_yFinal-m_yInicial)/m_temps;
	UpdateData(false);
}

//
// Les segents funcions s'activen quan algun dels quadres
// d'edici de text relacionats amb la velocitat de la cinta
// (posicions o temps) sn modificats. El que fan s cridar
// la funci 'actualitzaVelocitat()' per tal d'actualitzar
// el valor de la velocitat.
//
void CDlgCfgCella::OnChangeEditXinicial() 
{
	actualitzaVelocitat();
}

void CDlgCfgCella::OnChangeEditXfinal() 
{
	actualitzaVelocitat();	
}

void CDlgCfgCella::OnChangeEditTemps() 
{
	actualitzaVelocitat();	
}

void CDlgCfgCella::OnChangeEditYinicial() 
{
	actualitzaVelocitat();	
}

void CDlgCfgCella::OnChangeEditYfinal() 
{
	actualitzaVelocitat();	
}
