/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgCfgCella.h
//
// Descripci : Arxiu de capalera de la classe que mant
//				i permet solicitar a l'usuari la configuraci
//				dels elements de la cel.la.
//				La solicitud de dades a l'usuari, aix com la
//				seva vosualitzaci es fan mitjanant un
//				quadre de dileg.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_CONFIGURACIOCELLA_H__0230A384_F51E_11D3_B5E1_00C026C084F2__INCLUDED_)
#define AFX_CONFIGURACIOCELLA_H__0230A384_F51E_11D3_B5E1_00C026C084F2__INCLUDED_

#include <process.h>
#include "ScrIdentificacio.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDlgCfgCella : public CDialog
{
public:
	// Constructor
	CDlgCfgCella(CWnd* pParent = NULL);
	// Inicialitzaci
	void inicialitzar(void *sistema);
	// Finalitzaci
	void finalitzar();
	//  Les dades amb que treballa aquesta classe sn:
	//	* CString	m_nomArxiuObjectes;
	//	  Cont la ruta completa de l'arxiu que cont
	//    la definici d'objectes.
	//	* CString	m_nomArxiuScript;
	//    Cont la ruta completa de l'arxiu de script BSC
	//	  seleccionat.
	//	* int m_xp1, m_xp2, m_xr1, m_xr2, m_yp1, m_yp2, m_yr1, m_yr2;
	//	  Sn els valors dels punts de referncia en
	//	  la trasformaci del sistema de coordenades pantalla al
	//	  sistema de coordenades robot. Aquests punts sn els que
	//	  s'obtenen en el procs de calibratge de la cel.la.
	//	* long m_tempsRefresc;
	//	  Determina cada quan de temps s'agafa una mostra en
	//	  el procs d'anlisi de moviment. El temps es mesura
	//	  en milisegons.
	//	* int m_nMaxDeteccio;
	//	  Aquest valor s'empra en l'anlisi de moviment. Veure
	//	  la classe CPriAnalisiMoviment per a ms informaci al
	//	  respecte.
	//	* int m_nMaxInici;
	//	  Aquest valor s'empra en l'anlisi de moviment. Veure
	//	  la classe CPriAnalisiMoviment per a ms informaci al
	//	  respecte.
	//	* int m_tolerancia;
	//	  Aquest valor s'empra en l'anlisi de moviment. Veure
	//	  la classe CPriAnalisiMoviment per a ms informaci al
	//	  respecte.
	//	* int m_amplada;
	//	  Aquest valor s'empra en l'anlisi de moviment. Veure
	//	  la classe CPriAnalisiMoviment per a ms informaci al
	//	  respecte. El valor determina l'amplada de la imatge que
	//	  s'ha d'analitzar en la detecci de moviment.
	//	* float m_vx, m_vy, m_xFinal, m_xInicial, m_yFinal, m_yInicial, m_temps;
	//	  Aquests parmetres tenen a veure amb la velocitat
	//	  de la cinta transpostadora, i contenen informaci sobre
	//	  la posici d'un objecte damunt la cinta, la posici
	//	  de l'esmentat objecte passat un cert temps, el temps
	//	  en qesti, i el vector de velocitat de la cinta, 
	//	  obtingut a partir d'aquestes dades.
	//	* BOOL m_aturarCinta;
	//	  Indica si s'ha d'aturar la cinta una vegada es detecta
	//	  l'objecte, o no. En cas que no s'aturi, s'ha de tenir
	//	  en compte que la posici d'agafada dependr de la
	//	  posici en el moment de l'anlisi, de la velocitat
	//	  de la cinta, del temps que passa fins que s'envia 
	//	  l'ordre al robot i del temps que tarda el robot en 
	//	  executar l'acci.
	//	* float m_tempsAddicional;
	//	  Com que no es pot calcular el temps que tardar un
	//	  programa del robot en executar-se, aquest temps 
	//	  s'ha de saber des d'un principi. Aquest valor
	//	  (m_tempsAddicional) cont aquest temps, mesurat en
	//	  segons.

// Dialog Data
	//{{AFX_DATA(CDlgCfgCella)
	enum { IDD = IDD_CONFIGURAR_CEL_LA };
	CString	m_nomArxiuObjectes;
	CString	m_nomArxiuScript;
	int		m_xp1;
	int		m_xp2;
	int		m_xr1;
	int		m_xr2;
	int		m_yp1;
	int		m_yp2;
	int		m_yr1;
	int		m_yr2;
	long	m_tempsRefresc;
	int		m_nMaxDeteccio;
	int		m_nMaxInici;
	int		m_tolerancia;
	int		m_amplada;
	float	m_vx;
	float	m_vy;
	float	m_xFinal;
	float	m_xInicial;
	float	m_yFinal;
	float	m_yInicial;
	float	m_temps;
	BOOL	m_aturarCinta;
	float	m_tempsAddicional;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCfgCella)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgCfgCella)
	afx_msg void OnBotoCarregar();
	afx_msg void OnBotoRecarregar();
	afx_msg void OnBotoSelecScript();
	afx_msg void OnBotoEditar();
	afx_msg void OnBotoEditarscript();
	afx_msg void OnChangeEditXinicial();
	afx_msg void OnChangeEditXfinal();
	afx_msg void OnChangeEditTemps();
	afx_msg void OnChangeEditYinicial();
	afx_msg void OnChangeEditYfinal();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	// Es crida aquesta funci cada vegada que es modifica
	// manualment algun dels quadres de text relacionats
	// amb el clcul de la velocitat de la cinta.
	void actualitzaVelocitat();
	// Guarda els continguts d'aquest quadre de dileg.
	void guardar();
	// Carrega els continguts d'aquest quadre de dileg.
	void carregar();
	// Nom de l'arxiu a on guarda i des d'on carrega les dades.
	CString m_nomArxiu;
	// Punter a l'objecte global d'identificaci.
	CScrIdentificacio * m_ident;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFIGURACIOCELLA_H__0230A384_F51E_11D3_B5E1_00C026C084F2__INCLUDED_)
