/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgCfgGeneral.cpp
//
// Descripci : Arxiu d'implementaci de la classe que mant
//				i permet solicitar a l'usuari els parmetres
//				de configuraci general de l'aplicaci.
//				La solicitud de dades a l'usuari, aix com la
//				seva vosualitzaci es fan mitjanant un
//				quadre de dileg.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"
#include "DlgCfgGeneral.h"
#include "Sistema.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDlgCfgGeneral::CDlgCfgGeneral(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCfgGeneral::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCfgGeneral)
	m_tempsRefresc = 2000;
	m_mostrarFinestra = FALSE;
	//}}AFX_DATA_INIT
}


void CDlgCfgGeneral::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCfgGeneral)
	DDX_Text(pDX, IDC_EDIT_HIST_REFRESC, m_tempsRefresc);
	DDX_Check(pDX, IDC_CHECK_MOSTRAR_FINESTRA, m_mostrarFinestra);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCfgGeneral, CDialog)
	//{{AFX_MSG_MAP(CDlgCfgGeneral)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//
// Carrega les dades del dileg des de disc.
//
void CDlgCfgGeneral::carregar()
{
	CFile fitxer;
	if (!fitxer.Open(m_nomArxiu, CFile::modeRead)) return;
	CArchive arxiu(&fitxer, CArchive::load);

	arxiu >> m_tempsRefresc ;
	arxiu >> m_mostrarFinestra;

	arxiu.Close();
	fitxer.Close();
}

//
// Guarda les dades del dileg a disc
//
void CDlgCfgGeneral::guardar()
{
	CFile fitxer;
	if (!fitxer.Open(m_nomArxiu, CFile::modeWrite | CFile::modeCreate)) return;
	CArchive arxiu(&fitxer, CArchive::store);

	arxiu << m_tempsRefresc ;
	arxiu << m_mostrarFinestra;

	arxiu.Close();
	fitxer.Close();
}

//
// Inicialitza l'objecte
//
void CDlgCfgGeneral::inicialitzar(void *sistema)
{
	m_nomArxiu=((CSistema *)sistema)->m_arxiuConfiguracioGeneral;
	carregar();
}

//
// Realitza les tasques de finalitzaci de l'objecte
// entre elles, la de guardar l'estat de l'objecte a disc
//
void CDlgCfgGeneral::finalitzar()
{
	guardar();
}
