/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgCfgImatge.h
//
// Descripci : Arxiu de capalera de la classe que mant
//				i permet solicitar a l'usuari els parmetres
//				de configuraci del processat d'imatge.
//				La solicitud de dades a l'usuari, aix com la
//				seva vosualitzaci es fan mitjanant un
//				quadre de dileg.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_CONFIGURACIOIMATGE_H__1E06C6E2_F379_11D3_B5DA_00C026C084F2__INCLUDED_)
#define AFX_CONFIGURACIOIMATGE_H__1E06C6E2_F379_11D3_B5DA_00C026C084F2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDlgCfgImatge : public CDialog
{
public:
	// Constructor
	CDlgCfgImatge(CWnd* pParent = NULL);
	// Determina si el quadre de dileg s visible.
	BOOL estaActiu();
	// Activa o desactiva, segons correspongui, la visualitzaci
	// del quadre de dileg.
	void alternar();
	// Realitza les tasques de finalitzaci de l'objecte.
	void finalitzar();
	// Inicialitza l'objecte.
	void inicialitzar(void *sistema);

// Dialog Data
	//{{AFX_DATA(CDlgCfgImatge)
	enum { IDD = IDD_CONFIGURAR_IMATGE };
	BOOL	m_emfatitzarHistograma;
	UINT	m_altFinestra;
	UINT	m_ampleFinestra;
	UINT	m_llindarBinaritzacio;
	UINT	m_ampladaSuavitzat;
	UINT	m_minAmuntAvall;
	UINT	m_numDilatacions;
	UINT	m_numErosions;
	UINT	m_xFinestra;
	UINT	m_yFinestra;
	int		m_formaProcessat;
	UINT	m_tamanyMascara;
	int		m_estilSiluetes;
	UINT	m_ampladaSuavitzatAM;
	UINT	m_minAmuntAvallAM;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCfgImatge)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgCfgImatge)
	afx_msg void OnBotoAplicar();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	// Guarda l'estat de l'objecte en disc, en el fitxer el nom
	// del qual est en m_nomArxiu.
	void guardar();
	// Carrega l'estat de l'objecte des de disc, des del fitxer 
	// el nom del qual est en m_nomArxiu.
	void carregar();
	// Variable de cadena que cont el nom de l'arxiu des del
	// que es carreguen i a on es guarden les dades de l'objecte.
	CString m_nomArxiu;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFIGURACIOIMATGE_H__1E06C6E2_F379_11D3_B5DA_00C026C084F2__INCLUDED_)
