/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgCfgRobot.cpp
//
// Descripci : Aquesta classe proporciona mtodes per a
//				configurar els parmetres del robot: a quin
//				port de comunicacions est connectat, i quins
//				carcters dels que ens envia no volem
//				visualitzar.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"
#include "DlgCfgRobot.h"
#include "Sistema.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgRobot dialog


CDlgCfgRobot::CDlgCfgRobot(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCfgRobot::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCfgRobot)
	m_asciiminim = 32;
	m_nomostrar = _T("<>");
	m_numport = 0;
	//}}AFX_DATA_INIT
}


void CDlgCfgRobot::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCfgRobot)
	DDX_Text(pDX, IDC_EDIT_ASCIIMINIM, m_asciiminim);
	DDX_Text(pDX, IDC_EDIT_NOMOSTRAR, m_nomostrar);
	DDX_Radio(pDX, IDC_COM, m_numport);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCfgRobot, CDialog)
	//{{AFX_MSG_MAP(CDlgCfgRobot)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCfgRobot message handlers

void CDlgCfgRobot::inicialitzar(void *sistema)
{
	m_nomArxiu=((CSistema *)sistema)->m_arxiuConfiguracioRobot;
	carregar();
}

void CDlgCfgRobot::finalitzar()
{
	guardar();
}

void CDlgCfgRobot::carregar()
{
	CFile fitxer;
	if (!fitxer.Open(m_nomArxiu, CFile::modeRead)) return;
	CArchive arxiu(&fitxer, CArchive::load);

	arxiu >> m_nomostrar ;
	arxiu >> m_asciiminim ;
	arxiu >> m_numport ;

	arxiu.Close();
	fitxer.Close();
}

void CDlgCfgRobot::guardar()
{
	CFile fitxer;
	if (!fitxer.Open(m_nomArxiu, CFile::modeWrite | CFile::modeCreate)) return;
	CArchive arxiu(&fitxer, CArchive::store);

	arxiu << m_nomostrar ;
	arxiu << m_asciiminim ;
	arxiu << m_numport ;

	arxiu.Close();
	fitxer.Close();
}
