/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgTerminalRobot.cpp
//
// Descripci : Els objectes d'aquesta classe tnen capacitat
//				per a mostrar un quadre de dileg que simula
//				un terminal ASCII amb el qual comunicar-se amb
//				el robot.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BRAS.h"
#include "DlgTerminalRobot.h"
#include "Sistema.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgTerminalRobot dialog


CDlgTerminalRobot::CDlgTerminalRobot(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTerminalRobot::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgTerminalRobot)
	m_comanda = _T("");
	//}}AFX_DATA_INIT
}


void CDlgTerminalRobot::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgTerminalRobot)
	DDX_Control(pDX, IDC_LIST_TERMINAL, m_terminal);
	DDX_Text(pDX, IDC_EDIT_COMANDA, m_comanda);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgTerminalRobot, CDialog)
	//{{AFX_MSG_MAP(CDlgTerminalRobot)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_CLOSE, OnButtonOpenClose)
	ON_BN_CLICKED(IDC_BOTO_ENVIAR, OnBotoEnviar)
	ON_BN_CLICKED(IDC_BUTTON_MOVE0, OnButtonMove0)
	ON_BN_CLICKED(IDC_BUTTON_HOME, OnButtonHome)
	ON_BN_CLICKED(IDC_BUTTON_LIST, OnButtonList)
	ON_BN_CLICKED(IDC_BOTO_ABORT, OnBotoAbort)
	ON_BN_CLICKED(IDC_BOTO_CLS, OnBotoCls)
	ON_BN_CLICKED(IDC_BOTO_CINTAON, OnBotoCintaon)
	ON_BN_CLICKED(IDC_BOTO_CINTAOFF, OnBotoCintaoff)
	ON_MESSAGE(WM_ROB_REBUT, OnMissatgeRobot)		
	ON_BN_CLICKED(IDC_BOTO_TANCA, OnBotoTanca)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgTerminalRobot message handlers

BOOL CDlgTerminalRobot::OnInitDialog() 
{
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

LONG CDlgTerminalRobot::OnMissatgeRobot(WPARAM ch, LPARAM port)
{
	m_terminal.AddString(m_robot->obtenirRecepcio());
	m_terminal.SetTopIndex(m_terminal.GetTopIndex()+1);
	return 0;
}

void CDlgTerminalRobot::OnButtonOpenClose() 
{
	if (m_robotObert) {
		m_robot->tancar();
		m_robotObert=false;
	}
	else {
		m_robot->obrir();
		m_robotObert=true;
	}
}


void CDlgTerminalRobot::OnBotoEnviar() 
{
	UpdateData(true);
	m_robot->posarDirecte();
	m_robot->enviarComanda(m_comanda);
	m_comanda=_T("");
	UpdateData(false);
}

void CDlgTerminalRobot::OnButtonMove0() 
{
	m_robot->moure(0);	
}

void CDlgTerminalRobot::OnButtonHome() 
{
	m_robot->home();
}

void CDlgTerminalRobot::OnButtonList() 
{
	m_robot->enviarComanda("DIR");	
}

void CDlgTerminalRobot::OnBotoAbort() 
{
	m_robot->abortar();
}

void CDlgTerminalRobot::inicialitzar(void *sistema)
{
	Create(IDD_TERMINAL_ASCII);
	m_robot=&(((CSistema *)sistema)->m_robot);
	m_robot->modificarDialegANotificar(this);
	m_robot->posarDirecte();
	m_terminal.SubclassDlgItem(IDC_LIST_TERMINAL, this);
	m_robotObert=false;
}

void CDlgTerminalRobot::alternar()
{
	if (!esVisible()) {
		ShowWindow(SW_SHOW);
		SetDefID(IDC_BOTO_ENVIAR);
		GotoDlgCtrl( GetDlgItem(IDC_EDIT_COMANDA) );
	}
	else {
		ShowWindow(SW_HIDE);
	}
}

BOOL CDlgTerminalRobot::esVisible()
{
	return IsWindowVisible();
}

void CDlgTerminalRobot::OnBotoCls() 
{
	m_terminal.ResetContent();	
}

void CDlgTerminalRobot::OnOK()
{
	return;
}

void CDlgTerminalRobot::OnCancel()
{
	OnBotoTanca();
}

void CDlgTerminalRobot::OnBotoCintaon() 
{
	m_robot->activarCinta();
}

void CDlgTerminalRobot::OnBotoCintaoff() 
{
	m_robot->desactivarCinta();	
}

void CDlgTerminalRobot::OnBotoTanca() 
{
	ShowWindow(SW_HIDE);	
}
