/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgVisIdentificats.h
//
// Descripci : Visualitza objectes prviament identificats.
//				Per cada objecte en mostra les dades de la
//				classe a la qual pertany, s a dir, el nom
//				i els parmetres d'agafada (DX, DY i Rotaci).
//				Quan es fa click sobre un dels objectes, 
//				es passa a la classe vista la informaci
//				necessria per a que superposi a la imatge
//				de l'objecte el sistema de coordenades de
//				l'objecte en qesti. 
//				El sistema de coordenades es construeix
//				assumint un eix X en la direcci del vector
//				d'agafada per defecte, i un eix Y perpendicular
//				a ell i sobre el pl de la pantalla.
//				L'escala del sistema s tal que la longitud del
//				vector d'agafada per defecte es considera la
//				unitat.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_DIALEGOBJECTESIDENTIFICATS_H__9A30A2F2_F590_11D3_B5E2_00C026C084F2__INCLUDED_)
#define AFX_DIALEGOBJECTESIDENTIFICATS_H__9A30A2F2_F590_11D3_B5E2_00C026C084F2__INCLUDED_

//
// Arxius de capalera
//
#include "AuxObjecte.h"
#include "AuxPropietatObjecte.h"
#include "BRASDoc.h"
#include "BRASView.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDlgVisIdentificats : public CDialog
{
public:
	// Constructor
	CDlgVisIdentificats(CWnd* pParent = NULL);
	// Destructor
	~CDlgVisIdentificats();
	// Punter a la vista, emprat per a dibuixar el que calgui
	// sobre l'objecte visualitzat.
	CBRASView * m_laVista;
	// La llista dels objectes que es volen mostrar.
	CLlistaPropietatsObjectes m_llistaObjectes;

// Dialog Data
	//{{AFX_DATA(CDlgVisIdentificats)
	enum { IDD = IDD_OBJECTES_IDENTIFICATS };
	CListCtrl	m_listCtrlObjectes;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgVisIdentificats)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgVisIdentificats)
	virtual BOOL OnInitDialog();
	afx_msg void OnClickLlistaObjectes(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBotoAgafar();
	afx_msg void OnBotoMoure0();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	// Funcions de trasllaci i rotaci de punts. S'empren per
	// a calcular els punts a dibuixar per la vista, ja que
	// el vector d'agafada es defineix a partir de trasllacions
	// i rotacions de l'eix X del sistema de coordenades de
	// lo'objecte.
	CPoint traslladar(CPoint punt, int dx, int dy);
	CPoint rotar(CPoint punt, double angle);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIALEGOBJECTESIDENTIFICATS_H__9A30A2F2_F590_11D3_B5E2_00C026C084F2__INCLUDED_)
