/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgVisPropietats.cpp
//
// Descripci : Visualitza una llista de propietats d'objectes.
//				Detecta polsacions sobre la dita llista i posa
//				un punt vermell en el centre de gravetat de la
//				imatge de l'objecte que s'ha selccionat en la 
//				llista.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"
#include "DlgVisPropietats.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDlgVisPropietats::CDlgVisPropietats(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgVisPropietats::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgVisPropietats)
	//}}AFX_DATA_INIT
}

void CDlgVisPropietats::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgVisPropietats)
	DDX_Control(pDX, IDC_LIST_PROPIETATS_OBJECTES, m_listCtrlObjectes);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgVisPropietats, CDialog)
	//{{AFX_MSG_MAP(CDlgVisPropietats)
	ON_NOTIFY(NM_CLICK, IDC_LIST_PROPIETATS_OBJECTES, OnClickListPropietatsObjectes)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//
// OnInitDialog es crida just abans de visualitzar el quadre
// de dileg. 
// El que feim s omplir la llista del quadre de dileg
// amb les dades que volem visualitzar
//
BOOL CDlgVisPropietats::OnInitDialog() 
{
	LV_ITEM li;
	int i;
	m_laVista->m_dibuixarPunts=false;

	m_listCtrlObjectes.SubclassDlgItem(IDC_LIST_PROPIETATS_OBJECTES, this);
	m_listCtrlObjectes.DeleteAllItems();

	m_listCtrlObjectes.InsertColumn(1, "Compacitat", LVCFMT_LEFT, 80);
	m_listCtrlObjectes.InsertColumn(2, "Area", LVCFMT_LEFT, 50);
	m_listCtrlObjectes.InsertColumn(3, "Per", LVCFMT_LEFT, 40);
	m_listCtrlObjectes.InsertColumn(4, "(xc, yc)", LVCFMT_LEFT, 70);
	m_listCtrlObjectes.InsertColumn(5, "DMin", LVCFMT_LEFT, 40);
	m_listCtrlObjectes.InsertColumn(6, "DMax", LVCFMT_LEFT, 40);
	m_listCtrlObjectes.InsertColumn(7, "(xm, ym)", LVCFMT_LEFT, 70);
	m_listCtrlObjectes.InsertColumn(8, "(xM, yM)", LVCFMT_LEFT, 70);
	m_listCtrlObjectes.InsertColumn(9, "Orien", LVCFMT_LEFT, 65);

	li.mask=LVIF_TEXT;
	li.pszText=new char[50];

	for (i=0;i<m_llistaObjectes.GetSize();i++) {

		li.iItem=i;
		li.iSubItem=0;
		sprintf(li.pszText, "%f", m_llistaObjectes[i].m_compacitat);
		m_listCtrlObjectes.InsertItem(&li);

		li.iItem=i;
		li.iSubItem=1;
		sprintf(li.pszText, "%d", m_llistaObjectes[i].m_area);
		m_listCtrlObjectes.SetItem(&li);

		li.iItem=i;
		li.iSubItem=2;
		sprintf(li.pszText, "%d", m_llistaObjectes[i].m_perimetre);
		m_listCtrlObjectes.SetItem(&li);
		
		li.iItem=i;
		li.iSubItem=3;
		sprintf(li.pszText, "(%d, %d)", m_llistaObjectes[i].m_xCentre, m_llistaObjectes[i].m_yCentre);
		m_listCtrlObjectes.SetItem(&li);

		li.iItem=i;
		li.iSubItem=4;
		sprintf(li.pszText, "%d", m_llistaObjectes[i].m_dMin);
		m_listCtrlObjectes.SetItem(&li);

		li.iItem=i;
		li.iSubItem=5;
		sprintf(li.pszText, "%d", m_llistaObjectes[i].m_dMax);
		m_listCtrlObjectes.SetItem(&li);

		li.iItem=i;
		li.iSubItem=6;
		sprintf(li.pszText, "(%d, %d)", m_llistaObjectes[i].m_xDMin, m_llistaObjectes[i].m_yDMin);
		m_listCtrlObjectes.SetItem(&li);

		li.iItem=i;
		li.iSubItem=7;
		sprintf(li.pszText, "(%d, %d)", m_llistaObjectes[i].m_xDMax, m_llistaObjectes[i].m_yDMax);
		m_listCtrlObjectes.SetItem(&li);

		li.iItem=i;
		li.iSubItem=8;
		sprintf(li.pszText, "%d", m_llistaObjectes[i].m_orientacio);
		m_listCtrlObjectes.SetItem(&li);
	}

	return TRUE;  
}

CDlgVisPropietats::~CDlgVisPropietats()
{
	m_laVista->m_dibuixarPunts=false;
	m_laVista->RedrawWindow();
}

//
// Aquesta funci es crida quan es fa click sobre un element
// de la llista. En aquest cas s'indica a la vista que
// dibuixi un petit rectangle sobre el centre de gravetat
// de l'objecte seleccionat.
//
void CDlgVisPropietats::OnClickListPropietatsObjectes(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int elItem;
	elItem=m_listCtrlObjectes.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (elItem==-1) return;
	m_laVista->m_x=m_llistaObjectes[elItem].m_xCentre;
	m_laVista->m_y=m_llistaObjectes[elItem].m_yCentre;
	m_laVista->m_dibuixarPunts=true;
	m_laVista->RedrawWindow();
	*pResult = 0;
}
