/////////////////////////////////////////////////////////////////
//
// Arxiu      : DlgVisPropietats.h
//
// Descripci : Visualitza una llista de propietats d'objectes.
//				Detecta polsacions sobre la dita llista i posa
//				un punt vermell en el centre de gravetat de la
//				imatge de l'objecte que s'ha selccionat en la 
//				llista.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_DIALEGPROPIETATSOBJECTES_H__AAEA13B4_F3FD_11D3_B5DB_00C026C084F2__INCLUDED_)
#define AFX_DIALEGPROPIETATSOBJECTES_H__AAEA13B4_F3FD_11D3_B5DB_00C026C084F2__INCLUDED_

//
// Arxius de capalera
//
#include "AuxPropietatObjecte.h"
#include "BrasDoc.h"
#include "BrasView.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// DlgVisPropietats.h : header file
//

class CDlgVisPropietats : public CDialog
{
public:
	// Constructor
	CDlgVisPropietats(CWnd* pParent = NULL);
	// Destructor
	~CDlgVisPropietats();
	// La llista de les propietats.
	CLlistaPropietatsObjectes m_llistaObjectes;
	// Punter a la vista
	CBRASView * m_laVista;


// Dialog Data
	//{{AFX_DATA(CDlgVisPropietats)
	enum { IDD = IDD_PROPIETATS_OBJECTES };
	CListCtrl	m_listCtrlObjectes;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgVisPropietats)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgVisPropietats)
	virtual BOOL OnInitDialog();
	afx_msg void OnClickListPropietatsObjectes(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIALEGPROPIETATSOBJECTES_H__AAEA13B4_F3FD_11D3_B5DB_00C026C084F2__INCLUDED_)
