/////////////////////////////////////////////////////////////////
//
// Arxiu      : DspRobot.h
//
// Descripci : La classe DspRobot proporciona mtodes que
//				serveixen d'interfcie entre l'aplicaci
//				i el controlador del robot.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_ROBOT_H__9A06FF95_EF4B_11D3_B5D4_00C026C084F2__INCLUDED_)
#define AFX_ROBOT_H__9A06FF95_EF4B_11D3_B5D4_00C026C084F2__INCLUDED_

//
// Arxius de capalera
//
#include "SerialPort.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef CArray <CString, CString> CLlistaInstruccions;

#define ROB_Z_DEFECTE      1900
#define ROB_PITCH_DEFECTE  -900
#define ROB_ROLL_DEFECTE   0
#define ROB_PUNT_TEMPORAL  20
#define ROB_SALT_LINIA     13
#define ROB_MISSATGE_BUFFER_RECEPCIO_PLE "El Buffer de recepci est pl. Es procedeix al seu buidat."

#define WM_ROB_REBUT WM_USER + 10

class CDspRobot : public CDialog
{
public:
	void desactivarCinta();
	void activarCinta();
	void executarPrograma(CString nom, int temps, CString respostaEsperada);
	void executarPrograma (CString nom, int temps);
	void executarPrograma(CString nom);
	void enviarPrograma(CString nomArxiu, CString nomPrograma);
	void abortar();
	void modificarDialegANotificar(CWnd *nouDialeg);
	void tancar();
	void obrir();
	CString obtenirRecepcio();
	LONG OnCommunication(WPARAM ch, LPARAM port);
	bool obtenirPunt(int pt, int *x, int *y, int *z, int *p, int *r);
	void inicialitzar(void *sistema);
	void executarPrograma();
	void posarDiferit();
	void posarDirecte();
	void enviarComanda(const char *comanda);
	void home();
	void velocitat(int v);
	void moure (int x, int y, int z=ROB_Z_DEFECTE, int pitch=ROB_PITCH_DEFECTE, int roll=ROB_ROLL_DEFECTE);
	void moure(int p);
	void definirPunt(int p, int x, int y, int z=ROB_Z_DEFECTE, int pitch=ROB_PITCH_DEFECTE, int roll=ROB_ROLL_DEFECTE);
	CDspRobot(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDspRobot)
	enum { IDD = IDD_STUFF };
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDspRobot)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDspRobot)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool obtenirCadena(int pos, CString s, char *tmp);
	int posicioEnString(char ch, CString st);
	bool caracterEnString(char ch, CString st);
	CString m_noMostrar;
	char m_charMin;
	CWnd * m_dialegANotificar;
	CString m_tempStr;
	void executarComanda(const char *comanda);
	void processarComanda(const char *comanda);
	CLlistaInstruccions m_recepcio;	// Buffer de recepci
	int m_numPort;			// COM on est connectat el robot
	char m_sl[3];			// Array que cont el valor del salt
							// de lnia acceptat pel robot, 
							// seguit d'un zero. Preparat per a
							// concaternar-ho a totes les comandes
							// que s'envin cap al robot.
	bool m_directe;			// Si val true, totes les comandes 
							// s'envien directament cap al robot. 
							// Si val false, es guarden en un buffer
							// fins que es dni l'ordre d'enviar-les.
	CLlistaInstruccions m_instruccions; // Buffer d'instruccions
							// a enviar cap al robot.
	CSerialPort m_port;		// Objecte per al maneig del port srie.

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROBOT_H__9A06FF95_EF4B_11D3_B5D4_00C026C084F2__INCLUDED_)
