/****************************************************************/
/*  portable.h for IV-400                                       */
/*                                                              */
/*   This file contains most of the necessary definitions to a  */
/* portable programming environment.                            */
/****************************************************************/

#ifndef PORTABLE_H
#define PORTABLE_H

//#define KILL_INTERRUPT
#define _MEMORY_MAPPED_IO_ONLY

#if defined(_MSC_VER)
#define MSC
#endif 

#if defined(WIN32) || defined(_MTWIN16_)
#ifndef _WINDOWS
#define _WINDOWS
#endif
#endif

#if defined(_MTWIN32NT_)
#ifndef __NT__
#define __NT__
#endif
#endif

#if defined(WIN32) && !defined(__NT__)
#ifndef _MTWIN3295_
#define _MTWIN3295_
#endif
#endif      // _MTWIN3295_

#if defined(_DLL)
#define _WINDLL
#endif 

// The symbol "MSDOS" is always defined under MSC no matter
// creating DOS or Windows applications.
#if defined(MSDOS) && !defined(_WINDOWS) && !defined(WINVER)
#ifndef _MSDOS_
#define _MSDOS_ 1
#endif
#endif


#if defined(CPLUSPLUS) || defined(__cplusplus)
#ifndef _CPLUSPLUS_
#define _CPLUSPLUS_ 1
#endif
#else
/*
 * place where you want to get rid of some vendor's C extensions such
 * as 'const' and '__inline', etc
 */

#if defined(_MTLINUX_)
/* gcc does not recognize 'const', nor does it for '//' comment flag. */
#define const
#endif

/*
 * simply define __inline to be nothing will cause multiple definitions
 * errors if one inline has been defined in a header file and referenced
 * by more than one source code.
 */
/* #define __inline   static     */

#endif  /* #if defined(CPLUSPLUS) || defined(__cplusplus) */


#include "std_def.h"
#if defined(_WINDLL) || defined(_WINDOWS)
#include <windowsx.h>
#endif

#if defined(__BORLANDC__) || defined(__TURBOC__)
#include        <alloc.h>
#elif   defined(__WATCOMC__) && defined(__NT__) || \
		 defined(_MTPOWERPC_)
#define _MALLOC_H_INCLUDED
#else
#include        <malloc.h>
#endif


#if defined(_MSDOS_) || defined(_OS2) || (defined(__WATCOMC__) && \
		       (defined(__WINDOWS_386__) || defined(__NT__))) || \
			defined(_MTPOWERPC_) || defined(_MTLINUX_)
#define       MTMALLOC(size)    malloc(size)
#define       MTFREE(ptr)       free(ptr)
#else 
#define       MTMALLOC(size)    GlobalAllocPtr(GHND, (DWORD)(size))
#define       MTFREE(ptr)       GlobalFreePtr(ptr);
#define       MTMALLOC0(h, s)   LocalLock(((h) = LocalAlloc(LHND, (DWORD)(s))))
#define       MTFREE0(h, p)     (LocalUnlock(h), LocalFree(h))
#endif

/*--------------------------------------------------*/
/* "Portable C" compiler section                    */
/*--------------------------------------------------*/

/* OS/2 environment */
#if defined(_OS2)
#if defined(FAR)
#undef FAR
#endif
#if defined(_far)
#undef _far
#endif
#if defined(far)
#undef far
#endif
#if defined(HUGE)
#undef HUGE
#endif
#if defined(PASCAL)
#undef PASCAL
#endif

#define FAR
#define _far
#define far
#define HUGE
#define PASCAL

#endif

/* UN*X environment */
#if defined(_MTLINUX_)

#if defined(X11)
//#include <X11/Xlib.h>
//#include <X11/X.h>
//#include <X11/Intrinsic.h>
//#include <X11/StringDefs.h>
#endif

#if defined(FAR)
#undef FAR
#endif
#if defined(_far)
#undef _far
#endif
#if defined(far)
#undef far
#endif
#if defined(HUGE)
#undef HUGE
#endif
#if defined(PASCAL)
#undef PASCAL
#endif

#define FAR
#define _far
#define far
#define HUGE
#define PASCAL

#endif

/* Macintosh PowerPC environment */
#if defined(_MTPOWERPC_)


#if defined(FAR)
#undef FAR
#endif
#if defined(_far)
#undef _far
#endif
#if defined(far)
#undef far
#endif
#if defined(HUGE)
#undef HUGE
#endif
#if defined(PASCAL)
#undef PASCAL
#endif

#define FAR
#define _far
#define far
#define HUGE
#define PASCAL
#define NULL (void *)0
#define _fmemcpy        memcpy
#define strnicmp        strncmp
#endif


/* PC environment */
#if defined(__WATCOMC__) || defined(_MSC_VER)
#include <dos.h>            /* define register struct */

#if defined(__WATCOMC__)
/*--------------------------------------------------*/
/* WATCOM C/386 compiler section                    */
/*--------------------------------------------------*/

#if defined(__WINDOWS_386__) || defined(__NT__)
#if defined(FAR)
#undef FAR
#endif
#define FAR
#endif /* __WINDOWS_386__ */

#if defined(__386__) && !defined(__WINDOWS_386__) && !defined(__NT__)
#if defined(huge)
#undef huge
#endif
#define huge
#endif /* __386__ && !__WINDOWS_386__ */

#if defined(_MSDOS_)
typedef char * LPSTR ;    
#endif

#define MakeAddr(x,y)       (((ULONG)(x)<<4)+(y))

#define _REGS   REGS
#define _SREGS  SREGS
#ifndef __NT__
#define _int86   int386
#endif //__NT__
#define _getche getche
#define _getch  getch
#define _stat   stat

// The following lines are required for WATCOM C/C++ 9.0 but not 10.0
#if !defined(_FP_SEG)
#define _FP_SEG FP_SEG
#define _FP_OFF FP_OFF
#endif



union _REGS_ {
#if defined(__386__) && !defined(__WINDOWS_386__)
	struct DWORDREGS D;
#else
	struct WORDREGS  W;
#endif
	struct WORDREGS  X;
	struct BYTEREGS  H;
};

#define _SREGS_ SREGS
#define _STAT_  stat

#define _GETCHE_()  (flushall(),getche())
#define _GETCH_()   (flushall(),getch())
#define _KBHIT_     kbhit 
#ifdef _MEMORY_MAPPED_IO_ONLY
#define _INP_       IV4MemoryMappedIOReadByte
#define _OUTP_      IV4MemoryMappedIOWriteByte
#define _INPW_      IV4MemoryMappedIOReadWord
#define _OUTPW_     IV4MemoryMappedIOWriteWord
#define R_INP_       inp
#define R_OUTP_      outp
#define R_INPW_      inpw
#define R_OUTPW_     outpw
#else
#define _INP_       inp
#define _OUTP_      outp
#define _INPW_      inpw
#define _OUTPW_     outpw
#define R_INP_       inp
#define R_OUTP_      outp
#define R_INPW_      inpw
#define R_OUTPW_     outpw
#endif
#elif defined(_MSC_VER)
/*--------------------------------------------------*/
/* Microsoft C compiler section                     */
/*--------------------------------------------------*/

#if defined(_MSDOS_)
typedef char * LPSTR ;    
#endif

#define MakeAddr(x,y)       (((ULONG)(x)<<16)|(y))

// #define REGS    _REGS
// #define SREGS   _SREGS
#ifndef __NT__
#define int386  _int86
#define int386x _int86x
#endif //__NT__
#define int86   _int86
#define int86x  _int86x
#define getche  _getche
#define getch   _getch
#define stat    _stat
#define FP_SEG  _FP_SEG
#define FP_OFF  _FP_OFF

#if !defined(__NT__)            // !defined(_MTWIN3295_)

#if defined(_MTWIN3295_) || defined(__WATCOMC__) // for Windows 95 and __WATCOMC__ 386

struct _WORDREGS {
	unsigned short ax;
	unsigned short bx;
	unsigned short cx;
	unsigned short dx;
	unsigned short si;
	unsigned short di;
	unsigned short cflag;
	} ;

struct _BYTEREGS {
	unsigned char al, ah;
	unsigned char bl, bh;
	unsigned char cl, ch;
	unsigned char dl, dh;
	} ;

struct _SREGS {
	unsigned short es;
	unsigned short cs;
	unsigned short ss;
	unsigned short ds;
	} ;

#endif

#if !defined(__segment)
#define __segment   UWORD
#endif

union _REGS_ {
    struct _WORDREGS X;
    struct _BYTEREGS H;
    };
 
#endif

/* segment registers */

#define _SREGS_ _SREGS
#define _STAT_  _stat

#define _GETCHE_    _getche
#define _GETCH_     _getch
#define _KBHIT_     _kbhit
#ifdef _MEMORY_MAPPED_IO_ONLY
#define _INP_       IV4MemoryMappedIOReadByte
#define _OUTP_      IV4MemoryMappedIOWriteByte
#define _INPW_      IV4MemoryMappedIOReadWord
#define _OUTPW_     IV4MemoryMappedIOWriteWord
#define R_INP_       _inp
#define R_OUTP_      _outp
#define R_INPW_      _inpw
#define R_OUTPW_     _outpw
#else
#define _INP_       _inp
#define _OUTP_      _outp
#define _INPW_      _inpw
#define _OUTPW_     _outpw
#define R_INP_       _inp
#define R_OUTP_      _outp
#define R_INPW_      _inpw
#define R_OUTPW_     _outpw
#endif
#else
	<We are going no where!!!>
#endif /* #if defined(__WATCOMC__ */


#if defined(__WATCOMC__)
#if defined (__386__)
#ifndef __NT__
#define intx86(x,y,z)           int386((int)(x),(const union REGS *)(y),(union REGS *)(z))
#define intx86x(x,y,z,s)        int386x((int)(x),(const union REGS *)(y),(union REGS *)(z),(struct SREGS *)(s))
#endif  //__NT__
#else
#define intx86(x,y,z)           int86((int)(x),(const union REGS *)(y),(union REGS *)(z))
#define intx86x(x,y,z,s)        int86x((int)(x),(const union REGS *)(y),(union REGS *)(z),(struct SREGS *)(s))
#endif

#elif defined(_MSC_VER)

#if !defined(_MTWIN3295_)
#define intx86(x,y,z)           _int86((int)(x),(union _REGS *)(y),(union _REGS *)(z))
#define intx86x(x,y,z,s)        _int86x((int)(x),(union _REGS *)(y),(union _REGS *)(z),(struct _SREGS *)(s))

#else
#define __interrupt
#endif

#else
	<We are going no where!!!>
#endif  /* #if defined(__WATCOMC__) */

#endif /* #if (__WATCOMC__ && (_MSDOS_ || __OS2__)) || _MSC_VER */

#ifdef  __WATCOMC__
#define MakeAddr(x,y)       (((ULONG)(x)<<4)+(y))
#elif   defined(_MSC_VER)
#define MakeAddr(x,y)       (((ULONG)(x)<<16)|(y))
#endif

#define MTPROCALL   FAR PASCAL

#endif /* #ifndef PORTABLE_H */

#if defined(_WINDOWS) || defined(_MSDOS_)
#if defined(WIN32)
#define HUGE
#else
#define HUGE huge
#endif

#endif /* #ifndef PORTABLE_H */
