/*#**********************************************************************/
/*  Title: std_def.h  for IV-400        Module: genaral purpose header  */
/*  Description: This is the general header file for a lot of things.   */
/*###********************************************************************/

#ifndef STD_DEF_H
#define STD_DEF_H

#if defined(_MSC_VER)
#define MSC
#endif 

#if defined(_DLL)
#define _WINDLL
#endif 

/************************************************************************/
/* type define  and macro                                               */
/************************************************************************/

#if defined(__WATCOMC__) && \
    (defined(__WINDOWS__) || defined(__WINDOWS_386__) || defined(__NT__))
	/* nothing to do */
#else
#if !defined(_OS2)
typedef unsigned char   BYTE;
#endif // _OS2
#endif /* __WATCOMC__ && (__WINDOWS_386__ || __NT__) */


#if defined(MSC)  || defined(__TURBOC__) || defined(__BORLANDC__) \
	 || defined(_MTPOWERPC_)
#if defined(WIN32)              // Win32 Data Def.
typedef unsigned short  UWORD;
#define SIGNED  signed
#else                                   //      Dos and Win31 Data Def. Start
typedef unsigned char   BYTE;
typedef int             INT;
typedef unsigned short  UWORD;
typedef short           SWORD;
#if !defined(_WINDOWS)
typedef short           WORD;
typedef long            LONG;
#endif /* !defined(_WINDOWS) */
typedef unsigned long   ULONG;
#define SIGNED
#endif                                  // DOS and Win31 Data Def. End
#elif defined(SUNC)
typedef short           INT;
typedef unsigned short  UWORD;
typedef short           WORD;
typedef int             LONG;
typedef unsigned int    ULONG;

#elif defined(_MTLINUX_)
#define   BYTE   unsigned char
#define   INT    short
#define   UWORD  unsigned short
#define   WORD   short
#define   LONG   long
#define   ULONG  unsigned long

#elif defined(__WATCOMC__)
#if defined(MSDOS) || defined(__WINDOWS__)
typedef short           INT;
#if !defined(__WINDOWS__)
typedef short           WORD;
typedef long            LONG;
#endif
typedef unsigned short  UWORD;
typedef unsigned long   ULONG;
#define SIGNED  signed
#elif defined(__WINDOWS_386__)
typedef short           INT;
typedef unsigned short  UWORD;
typedef unsigned long   ULONG;
#elif defined(__NT__)
typedef unsigned short  UWORD;
#define SIGNED  signed
#endif /* MSDOS-else */
#endif /* MSC-else */

#if defined(_OS2)
typedef short  WORD;
typedef unsigned short  UWORD;
typedef unsigned long   DWORD;
typedef unsigned long   HANDLE;
typedef unsigned long   HDRIVER;
typedef void * FARPOINTER;
typedef char * LPSTR;
typedef DWORD * LPDWORD;
typedef void    (*FARPROC) (short);
#endif


/************************************************************************/
/* define genaral parameters                                            */
/************************************************************************/

#define BYTE_SIZE       8
				/* genaral bit mask starting with a "b" */

#define bMSB            0x8000          /* MSBit pattern for 16 bit     */
#define bLSB            0x0001          /* LSBit mask for 16 bit        */
#define bBYTE_MSB       0x80            /* MSBit mask for 8 bit         */
#define bBYTE_LSB       0x01            /* LSBit mask for 8 bit         */
#define bMSBYTE         0xff00          /* MSByte mask for 16 bit       */
#define bLSBYTE         0x00ff          /* LSByte mask for 16 bit       */

#define bINTMASK        0xffff          /* Mask for INT type            */
#define b24BMASK        0xffffff        /* Mask for 24 bit from a LONG  */

#define RESET           0
#define SET             1

#define MAX_F_NAME_LEN  64              /* max. char # of file name     */
#define DBUFLEN         4096            /* disk R/W buffer size */

#if defined(SUNC)
#define CLK_TCK         1000000         /* SUN clock unit is micro S    */
#elif defined(MSC) || defined(__TURBOC__) || defined(__BORLANDC__)
#include <time.h>                       /* TURBO-C clock units          */
//#define CLK_TCK       1000            /* DOS clock unit is milli S    */
#endif /* SUNC-MSC-TURBOC */

/************************************************************************/
/* define file related parameters                                       */
/************************************************************************/

#if defined(MSC) || defined(__WATCOMC__) || defined(__TURBOC__) \
    || defined(__BORLANDC__) || defined(_OS2)
#include <io.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#if defined(_WINDOWS)           /* Windows specifics */
#define D_READ          OF_READ | OF_SHARE_DENY_WRITE
#define D_WRITE         0       /* write - for _lcreat */
#define D_RDWT          OF_READWRITE | OF_SHARE_DENY_WRITE
#define D_WTRD          D_RDWT

#define T_READ          OF_READ | OF_SHARE_DENY_WRITE
#define T_WRITE         OF_WRITE | OF_CREATE | OF_SHARE_DENY_NONE 
#define T_RDWT          OF_READWRITE | OF_CREATE | OF_SHARE_DENY_WRITE
#define DFMODE          D_RDWT
#define OPEN            _lopen
#define LCREAT          _lcreat
#else   /* NON Windows */
#define D_READ          O_RDONLY | O_BINARY
#define D_WRITE         O_WRONLY | O_BINARY | O_CREAT | O_TRUNC, S_IWRITE
#define D_RDWT          O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IWRITE
#define D_WTRD          O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IWRITE

#define T_READ          O_RDONLY
#define T_WRITE         O_WRONLY | O_CREAT | O_TRUNC, S_IWRITE
#define T_RDWT          O_RDWR | O_CREAT | O_TRUNC, S_IWRITE
#define DFMODE          D_WTRD
#define LCREAT          open
#define OPEN            open
#define CLOSE           close
#endif /* _WINDOWS-else */

#elif defined(_MTPOWERPC_)
#include <fcntl.h>
#define D_READ          O_RDONLY | O_BINARY
#define D_WRITE         O_WRONLY | O_BINARY | O_CREAT | O_TRUNC
#define D_RDWT          O_RDWR | O_BINARY | O_CREAT | O_TRUNC
#define D_WTRD          O_RDWR | O_BINARY | O_CREAT | O_TRUNC
#define OPEN            open

#elif defined(SUNC) || defined(_MTLINUX_)

#define D_READ          0
#define D_WRITE         1
#define D_RDWT          2
#define D_WTRD          D_RDWT       /* same under UNIX */

#define DFMODE          0644            /* data file, rw for owner, r for
					   others */
#define LCREAT          creat
#endif  /* MSC-elif */                            

/************************************************************************/
/* define error codes                                                   */
/************************************************************************/

#define OK              0

#define GEN_ERROR       -1
#define ALLOC_ERROR     -2
#define PARA_ERROR      -3

#define FILE_ERROR      -5
#define READ_ERROR      -6
#define WRITE_ERROR     -7
#define FORMAT_ERROR    -8

#define MATH_ERROR      -10
#define HW_ERROR        -12
#define MEM_ERROR       -13

#define SYS_ERROR       -20


#if !defined(_WINDOWS) && !defined(__WINDOWS_386__) && !defined(__NT__)
#define FAR
#define PASCAL
#define NEAR 
#endif /* !_WINDOWS && !__WINDOWS_386__ && !__NT__ */

#endif /* !STD_DEF_H */

/*--------------------------   end of std_def.h  -----------------------*/

