/////////////////////////////////////////////////////////////////
//
// Arxiu      : MainFrm.cpp
//
// Descripci : L'aplicaci t un sol objecte de tipus CMainFrm.
//				La seva funci bsica s la de respondre als
//				events de selecci d'opcions de men.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"

#include "MainFrm.h"
#include "BRASDoc.h"
#include "BRASView.h"

#include "ScrIdentificacio.h"
#include "DlgVisPropietats.h"
#include "DlgTerminalRobot.h"
#include "DlgCfgNomPrograma.h"
#include "ScrInterpret.h"
#include "PriImatge.h"
#include "iv4.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_MOVE()
	ON_COMMAND(IDM_CAMARA_INICIAR_GRAVACIO, OnCamaraIniciarGravacio)
	ON_COMMAND(IDM_CAMARA_ATURAR_GRAVACIO, OnCamaraAturarGravacio)
	ON_COMMAND(IDM_CAMARA_CAPTURAR_FOTOGRAMA, OnCamaraCapturarFotograma)
	ON_UPDATE_COMMAND_UI(IDM_CAMARA_INICIAR_GRAVACIO, OnUpdateCamaraIniciarGravacio)
	ON_UPDATE_COMMAND_UI(IDM_CAMARA_ATURAR_GRAVACIO, OnUpdateCamaraAturarGravacio)
	ON_COMMAND(IDM_IMATGE_CONFIGURAR, OnImatgeConfigurar)
	ON_COMMAND(IDM_IMATGE_BINARITZAR, OnImatgeBinaritzar)
	ON_COMMAND(IDM_IMATGE_THRESHOLD, OnImatgeThreshold)
	ON_COMMAND(IDM_IMATGE_EROSIONAR, OnImatgeErosionar)
	ON_COMMAND(IDM_IMATGE_DILATAR, OnImatgeDilatar)
	ON_COMMAND(IDM_IMATGE_PROCES, OnImatgeProces)
	ON_COMMAND(IDM_IMATGE_PROPIETATS, OnImatgePropietats)
	ON_COMMAND(IDM_VEURE_HISTOGRAMA, OnVeureHistograma)
	ON_UPDATE_COMMAND_UI(IDM_VEURE_HISTOGRAMA, OnUpdateVeureHistograma)
	ON_COMMAND(IDM_VEURE_PREFERENCIES, OnVeurePreferencies)
	ON_UPDATE_COMMAND_UI(IDM_IMATGE_CONFIGURAR, OnUpdateImatgeConfigurar)
	ON_COMMAND(IDM_ROBOT_TERMINAL, OnRobotTerminal)
	ON_UPDATE_COMMAND_UI(IDM_ROBOT_TERMINAL, OnUpdateRobotTerminal)
	ON_COMMAND(IDM_ROBOT_DOWNLOAD, OnRobotDownload)
	ON_COMMAND(IDM_ROBOT_CONFIGURAR, OnRobotConfigurar)
	ON_COMMAND(IDM_CELLA_CONFIGURAR, OnCellaConfigurar)
	ON_COMMAND(IDM_CELLA_IDENTIFICAR, OnCellaIdentificar)
	ON_COMMAND(ID_CELLA_SCRIPT, OnCellaScript)
	ON_COMMAND(IDM_CELLA_CALIBRAR, OnCellaCalibrar)
	ON_COMMAND(IDM_CELLA_ENDAVANT, OnCellaEndavant)
	ON_UPDATE_COMMAND_UI(IDM_CELLA_ENDAVANT, OnUpdateCellaEndavant)
	ON_COMMAND(IDM_CELLA_VCINTA, OnCellaVcinta)
	ON_COMMAND(IDM_CELLA_CREAE_CRITERIS, OnCellaCrearCriteris)
	ON_UPDATE_COMMAND_UI(IDM_CELLA_CREAE_CRITERIS, OnUpdateCellaCrearCriteris)
	ON_COMMAND(ID_AJUDA_IV400, OnAjudaIv400)
	ON_COMMAND(ID_ARXIU_SAVE, OnArxiuSave)
	//}}AFX_MSG_MAP
	// Global help commands
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_RIGHT | CBRS_ALIGN_BOTTOM);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar, AFX_IDW_DOCKBAR_RIGHT);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		| WS_THICKFRAME | WS_SYSMENU | WS_MAXIMIZEBOX 
		| WS_MINIMIZEBOX;

	if (!CFrameWnd::PreCreateWindow(cs)) return FALSE;
	cs.style &= ~FWS_ADDTOTITLE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y);
	((CBRASView *)GetActiveView())->m_sistema.m_camara.moureFinestra(x+2, y+2);
}

void CMainFrame::OnCamaraIniciarGravacio() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_camara.iniciarGravacio();
}

void CMainFrame::OnCamaraAturarGravacio() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_camara.aturarGravacio();
}

void CMainFrame::OnCamaraCapturarFotograma() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_camara.capturarFotograma();
}

void CMainFrame::OnUpdateCamaraIniciarGravacio(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!((CBRASView *)GetActiveView())->m_sistema.m_camara.estaGravant());		
}

void CMainFrame::OnUpdateCamaraAturarGravacio(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(((CBRASView *)GetActiveView())->m_sistema.m_camara.estaGravant());			
}

void CMainFrame::OnImatgeConfigurar() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_imgconfig.alternar();
}

void CMainFrame::OnImatgeBinaritzar() 
{
	// Obtenim punters a la camara i la configuraci del procs
	// de la imatge globals.
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspCamara *cam=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	// Es crea una imatge amb les mides adequades.
	CPriImatge laImatge;
	laImatge.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	// Es captura el fotograma
	OnCamaraCapturarFotograma();
	cam->posarEnMemoria(&laImatge);
	// Es realitza la binaritzac
	laImatge.binaritzar(cimg->m_llindarBinaritzacio);
	// Es visualitza el resultat
	cam->llegirDeMemoria(&laImatge);
}

void CMainFrame::OnImatgeThreshold() 
{
	// Obtenim punters a la camara i la configuraci del procs
	// de la imatge globals.
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspCamara *cam=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	// Es crea una imatge amb les mides adequades.
	CPriImatge laImatge;
	laImatge.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	// Es captura el fotograma
	OnCamaraCapturarFotograma();
	cam->posarEnMemoria(&laImatge);
	// Es realitza la binaritzac
	laImatge.threshold(9999, cimg->m_emfatitzarHistograma, cimg->m_ampladaSuavitzat, cimg->m_minAmuntAvall, cimg->m_minAmuntAvall);
	laImatge.ferThresholdVisible();
	// Es visualitza el resultat
	cam->llegirDeMemoria(&laImatge);
}

void CMainFrame::OnImatgeErosionar() 
{
	UINT i;
	// Obtenim punters a la camara i la configuraci del procs
	// de la imatge globals.
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspCamara *cam=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	// Es crea una imatge amb les mides adequades.
	CPriImatge laImatge;
	laImatge.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	// Es captura el fotograma
	OnCamaraCapturarFotograma();
	cam->posarEnMemoria(&laImatge);
	// Es realitza la binaritzac
	laImatge.threshold(9999, cimg->m_emfatitzarHistograma, cimg->m_ampladaSuavitzat, cimg->m_minAmuntAvall, cimg->m_minAmuntAvall);
	// Es fa l'erosi
	for (i=0;i<cimg->m_numErosions;i++)
		laImatge.erosionar(cimg->m_tamanyMascara);
	laImatge.ferThresholdVisible();
	// Es visualitza el resultat
	cam->llegirDeMemoria(&laImatge);
}


void CMainFrame::OnImatgeDilatar() 
{
	UINT i;
	// Obtenim punters a la camara i la configuraci del procs
	// de la imatge globals.
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspCamara *cam=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	// Es crea una imatge amb les mides adequades.
	CPriImatge laImatge;
	laImatge.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	// Es captura el fotograma
	OnCamaraCapturarFotograma();
	cam->posarEnMemoria(&laImatge);
	// Es realitza la binaritzac
	laImatge.threshold(9999, cimg->m_emfatitzarHistograma, cimg->m_ampladaSuavitzat, cimg->m_minAmuntAvall, cimg->m_minAmuntAvall);
	// Es fa l'erosi
	for (i=0;i<cimg->m_numDilatacions;i++)
		laImatge.dilatar(cimg->m_tamanyMascara);
	laImatge.ferThresholdVisible();
	// Es visualitza el resultat
	cam->llegirDeMemoria(&laImatge);
}

void CMainFrame::OnImatgeProces() 
{
	// Obtenim punters a la camara i la configuraci del procs
	// de la imatge globals.
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspCamara *cam=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	// Es crea una imatge amb les mides adequades.
	CPriImatge laImatge;
	laImatge.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	// Es captura el fotograma
	OnCamaraCapturarFotograma();
	cam->posarEnMemoria(&laImatge);
	// Realitza el procs de la imatge
	(((CBRASView *)GetActiveView())->m_sistema).realitzarProcesImatge(&laImatge);
	// Visualitza el resultat.
	laImatge.ferThresholdVisible();
	cam->llegirDeMemoria(&laImatge);
	return;
}

void CMainFrame::OnImatgePropietats() 
{
	int i, xc, yc, per, xmn, ymn, dmn, xmx, ymx, dmx;
	long area;
	double comp, orien;

	// Obtenim punters a la camara i la configuraci del procs
	// de la imatge globals.
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspCamara *cam=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	// Es crea una imatge amb les mides adequades.
	CPriImatge laImatge, laImatgeTemporal;
	CPriImgMarques marques;
	CPriRegio regio;
	laImatge.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	laImatgeTemporal.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	marques.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	regio.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	// Es captura el fotograma
	OnCamaraCapturarFotograma();
	cam->posarEnMemoria(&laImatge);
	// Posa la imatge adequade en l'espai temporal segons el que
	// s'hagi determinat en les preferncies.
	switch (cimg->m_estilSiluetes) {
	case 0 : break;
	case 1 : break;
	case 2 : laImatgeTemporal=laImatge; break;
	}
	// Realitza el procs de la imatge
	(((CBRASView *)GetActiveView())->m_sistema).realitzarProcesImatge(&laImatge);
	// Crea la imatge de marques
	laImatge.crearMarques(&marques);

	CDlgVisPropietats propietats ;
	// Itera i per cada regi n'obt les propietats.
	for (i=1;i<marques.obtenirNumMarques();i++) {
		marques.crearRegio(i, &regio);
		area = regio.obtenirArea();
		regio.obtenirCentreGravetat(&xc, &yc);
		// Dibuixa el contorn sols si el volem veure.
		if (cimg->m_estilSiluetes==0)
			per = regio.obtenirPerimetre(NULL);
		else 
			per = regio.obtenirPerimetre(&laImatgeTemporal);

		comp = regio.obtenirCompacitat();
		regio.obtenirDMin(&xmn, &ymn, &dmn);
		regio.obtenirDMax(&xmx, &ymx, &dmx);

		if (cimg->m_estilSiluetes!=0) {
			laImatgeTemporal.dibuixarPunt(xc, yc, 2);
			laImatgeTemporal.dibuixarPunt(xmn, ymn, 2);
			laImatgeTemporal.dibuixarPunt(xmx, ymx, 2);
		}

		orien = regio.obtenirOrientacio();
		propietats.m_llistaObjectes.Add(CAuxPropietatObjecte(per, xc, yc, area, xmn, xmx, ymn, ymx, dmn, dmx, comp, orien));
	}
	if (cimg->m_estilSiluetes!=0) cam->llegirDeMemoria(&laImatgeTemporal);
	propietats.m_laVista=(CBRASView *)GetActiveView();
	propietats.DoModal();
}

void CMainFrame::OnVeureHistograma() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_histograma.alternar();	
}

void CMainFrame::OnUpdateVeureHistograma(CCmdUI* pCmdUI) 
{
	if (((CBRASView *)GetActiveView())->m_sistema.m_histograma.estaActiu()) 
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CMainFrame::OnVeurePreferencies() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_genconfig.DoModal();
	((CBRASView *)GetActiveView())->RedrawWindow();
}

void CMainFrame::OnUpdateImatgeConfigurar(CCmdUI* pCmdUI) 
{
	if (((CBRASView *)GetActiveView())->m_sistema.m_imgconfig.estaActiu()) 
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}


void CMainFrame::OnRobotTerminal() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_terminal.alternar();
}

void CMainFrame::OnUpdateRobotTerminal(CCmdUI* pCmdUI) 
{
	if (((CBRASView *)GetActiveView())->m_sistema.m_terminal.esVisible())
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CMainFrame::OnRobotDownload() 
{
	char directoriActual[250];
	CDlgCfgNomPrograma ndlg;
	static char BASED_CODE szFilter[] = "Arxius ACL (*.acl)|*.acl|Tots els Arxius (*.*)|*.*||";
	CFileDialog fdlg(true, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	GetCurrentDirectory(200, directoriActual);
	ndlg.m_nomPrograma=_T("");
	while (ndlg.m_nomPrograma==_T("")) 
		ndlg.DoModal();
	if (fdlg.DoModal()==IDOK) 
		((CBRASView *)GetActiveView())->m_sistema.m_robot.enviarPrograma(fdlg.GetPathName(), ndlg.m_nomPrograma);
	SetCurrentDirectory(directoriActual);
}

void CMainFrame::OnRobotConfigurar() 
{
	if (((CBRASView *)GetActiveView())->m_sistema.m_robconfig.DoModal()==IDOK)
		AfxMessageBox(MFR_NOEFECTE_FINS_REINICI);
}

void CMainFrame::OnCellaConfigurar() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_cellconfig.DoModal();
	((CBRASView *)GetActiveView())->RedrawWindow();
}

void CMainFrame::OnCellaIdentificar() 
{
	int i, xc, yc, per, xmn, ymn, dmn, xmx, ymx, dmx;
	long area;
	double comp, orien;
	CAuxObjecte *objecte;
	CDlgVisIdentificats objectesIdentificats;

	float tinicial, tfinal;
	FILE *fp;

	tinicial=(float)clock();

	// Obtenim punters a la camara i la configuraci del procs
	// de la imatge globals.
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspCamara *cam=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	// Es crea una imatge amb les mides adequades.
	CPriImatge laImatge, laImatgeTemporal;
	CPriImgMarques marques;
	CPriRegio regio;
	laImatge.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	laImatgeTemporal.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	marques.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	regio.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	// Es captura el fotograma
	OnCamaraCapturarFotograma();
	cam->posarEnMemoria(&laImatge);
	// Posa la imatge adequade en l'espai temporal segons el que
	// s'hagi determinat en les preferncies.
	switch (cimg->m_estilSiluetes) {
	case 0 : break;
	case 1 : break;
	case 2 : laImatgeTemporal=laImatge; break;
	}
	// Realitza el procs de la imatge
	(((CBRASView *)GetActiveView())->m_sistema).realitzarProcesImatge(&laImatge);
	// Crea la imatge de marques
	laImatge.crearMarques(&marques);

	// Itera i per cada regi n'obt les propietats.
	for (i=1;i<marques.obtenirNumMarques();i++) {
		marques.crearRegio(i, &regio);
		area = regio.obtenirArea();
		regio.obtenirCentreGravetat(&xc, &yc);
		// Dibuixa el contorn sols si el volem veure.
		if (cimg->m_estilSiluetes==0)
			per = regio.obtenirPerimetre(NULL);
		else 
			per = regio.obtenirPerimetre(&laImatgeTemporal);

		comp = regio.obtenirCompacitat();
		regio.obtenirDMin(&xmn, &ymn, &dmn);
		regio.obtenirDMax(&xmx, &ymx, &dmx);

		if (cimg->m_estilSiluetes!=0) {
			laImatgeTemporal.dibuixarPunt(xc, yc, 2);
			laImatgeTemporal.dibuixarPunt(xmn, ymn, 2);
			laImatgeTemporal.dibuixarPunt(xmx, ymx, 2);
		}

		orien = regio.obtenirOrientacio();
		objecte=((CBRASView *)GetActiveView())->m_sistema.m_identificacio.identificarObjecte(area, per, dmn, dmx, comp);
		if (objecte==NULL) {
			objectesIdentificats.m_llistaObjectes.Add(CAuxPropietatObjecte(per, xc, yc, area, xmn, xmx, ymn, ymx, dmn, dmx, comp, orien, new CAuxObjecte("Indefinit", 0, 0, 0)));
		}
		else
			objectesIdentificats.m_llistaObjectes.Add(CAuxPropietatObjecte(per, xc, yc, area, xmn, xmx, ymn, ymx, dmn, dmx, comp, orien, objecte));

	}
	if (cimg->m_estilSiluetes!=0) cam->llegirDeMemoria(&laImatgeTemporal);

	tfinal=(float)clock();
	fp=fopen("tonilog.log", "a+");
	fprintf(fp, "%f\n", (tfinal-tinicial)/(CLOCKS_PER_SEC));
	fclose(fp);

	objectesIdentificats.m_laVista=(CBRASView *)GetActiveView();
	objectesIdentificats.DoModal();
}

void CMainFrame::OnCellaScript() 
{
	int i, xc, yc, per, xmn, ymn, dmn, xmx, ymx, dmx;
	long area;
	double comp, orien;
	CAuxObjecte *objecte;
	CPoint p;
	float tinicial, tfinal;

	FILE *fp;
	
	if (((CBRASView *)GetActiveView())->m_sistema.m_cellconfig.m_nomArxiuScript==_T("")) {
		static char BASED_CODE szFilter[] = "Scripts d'actuaci de BRAS (*.bsc)|*.bsc|Tots els Arxius (*.*)|*.*||";
		CFileDialog fdlg(true, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
		if (fdlg.DoModal()==IDOK) 
			((CBRASView *)GetActiveView())->m_sistema.m_cellconfig.m_nomArxiuScript=fdlg.GetPathName();
		else return;
	}

	tinicial=(float)clock();

	// Obtenim punters a la camara i la configuraci del procs
	// de la imatge globals.
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspCamara *cam=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	// Es crea una imatge amb les mides adequades.
	CPriImatge laImatge, laImatgeTemporal;
	CPriImgMarques marques;
	CPriRegio regio;
	laImatge.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	laImatgeTemporal.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	marques.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	regio.inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	// Es captura el fotograma
	OnCamaraCapturarFotograma();
	cam->posarEnMemoria(&laImatge);
	// Posa la imatge adequade en l'espai temporal segons el que
	// s'hagi determinat en les preferncies.
	switch (cimg->m_estilSiluetes) {
	case 0 : break;
	case 1 : break;
	case 2 : laImatgeTemporal=laImatge; break;
	}
	// Realitza el procs de la imatge
	(((CBRASView *)GetActiveView())->m_sistema).realitzarProcesImatge(&laImatge);
	// Crea la imatge de marques
	laImatge.crearMarques(&marques);

	((CBRASView *)GetActiveView())->m_sistema.m_interpret.m_objectes.RemoveAll();
	// Itera i per cada regi n'obt les propietats.
	for (i=1;i<marques.obtenirNumMarques();i++) {
		marques.crearRegio(i, &regio);
		area = regio.obtenirArea();
		regio.obtenirCentreGravetat(&xc, &yc);
		// Dibuixa el contorn sols si el volem veure.
		if (cimg->m_estilSiluetes==0)
			per = regio.obtenirPerimetre(NULL);
		else 
			per = regio.obtenirPerimetre(&laImatgeTemporal);

		comp = regio.obtenirCompacitat();
		regio.obtenirDMin(&xmn, &ymn, &dmn);
		regio.obtenirDMax(&xmx, &ymx, &dmx);

		if (cimg->m_estilSiluetes!=0) {
			laImatgeTemporal.dibuixarPunt(xc, yc, 2);
			laImatgeTemporal.dibuixarPunt(xmn, ymn, 2);
			laImatgeTemporal.dibuixarPunt(xmx, ymx, 2);
		}

		orien = regio.obtenirOrientacio();
		objecte=((CBRASView *)GetActiveView())->m_sistema.m_identificacio.identificarObjecte(area, per, dmn, dmx, comp);

		if (objecte==NULL) {
			((CBRASView *)GetActiveView())->m_sistema.pantallaARobot(&xc, &yc, &orien);
			((CBRASView *)GetActiveView())->m_sistema.m_interpret.m_objectes.Add(CAuxPropietatObjecte("INDEFINIT", per, xc, yc, area, xmn, xmx, ymn, ymx, dmn, dmx, comp, orien));
		}
		else {
			((CBRASView *)GetActiveView())->m_sistema.calcularAgafada(objecte, &xc, &yc, &orien, xmn, ymn);
			((CBRASView *)GetActiveView())->m_sistema.pantallaARobot(&xc, &yc, &orien);
			((CBRASView *)GetActiveView())->m_sistema.m_interpret.m_objectes.Add(CAuxPropietatObjecte(objecte->obtenirNom(), per, xc, yc, area, xmn, xmx, ymn, ymx, dmn, dmx, comp, orien));
		}
	}
	if (cimg->m_estilSiluetes!=0) cam->llegirDeMemoria(&laImatgeTemporal);

	tfinal=(float)clock();
	fp=fopen("tonilog.log", "a+");
	fprintf(fp, "%f\n", (tfinal-tinicial)/(CLOCKS_PER_SEC));
	fclose(fp);

	((CBRASView *)GetActiveView())->m_sistema.m_interpret.actuacioDesdeExecucioScript();
	((CBRASView *)GetActiveView())->m_sistema.m_interpret.executar(((CBRASView *)GetActiveView())->m_sistema.m_cellconfig.m_nomArxiuScript);
}

void CMainFrame::OnCellaCalibrar() 
{
	int x1, y1, x2, y2, z, p, r;
	if (AfxMessageBox("El procs de calibraci reconfigura l'entorn de treball, de forma que una calibraci errnia conduir a un comportament inadequat de tot el sistema. Estau segur de que voleu continuar?", MB_OKCANCEL)!=IDOK) return;
	AfxMessageBox("Situau manualment el robot sobre el primer punt de calibraci i emmagatzemau el punt com a '1'. Seguidament, feis el mateix amb el segon punt i emmagatzemau-lo com a '2'. Quan ho hagiu fet, premeu 'Acceptar'");
	if (!((CBRASView *)GetActiveView())->m_sistema.m_robot.obtenirPunt(1, &x1, &y1, &z, &p, &r)) {
		AfxMessageBox("Problemes llegint el punt 1 del controlador del robot. Revisau que funcioni correctament");
		return;
	}
	if (!((CBRASView *)GetActiveView())->m_sistema.m_robot.obtenirPunt(2, &x2, &y2, &z, &p, &r)) {
		AfxMessageBox("Problemes llegint el punt 2 del controlador del robot. Revisau que funcioni correctament");
		return;
	}
	((CBRASView *)GetActiveView())->m_sistema.m_cellconfig.m_xr1=x1;
	((CBRASView *)GetActiveView())->m_sistema.m_cellconfig.m_yr1=y1;
	((CBRASView *)GetActiveView())->m_sistema.m_cellconfig.m_xr2=x2;
	((CBRASView *)GetActiveView())->m_sistema.m_cellconfig.m_yr2=y2;
	AfxMessageBox("Ara heu de fer click amb el ratol sobre el primer objecte, i a continuaci sobre el segon. Pitjau 'Acceptar' per a fer-ho");
	((CBRASView *)GetActiveView())->m_puntCapturat=0;
}

void CMainFrame::OnCellaEndavant() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_analisi.alternar();	
}

void CMainFrame::OnUpdateCellaEndavant(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(((CBRASView *)GetActiveView())->m_sistema.m_analisi.estaActiu());			
}

void CMainFrame::OnCellaVcinta() 
{
	CDspCamara *camara=&(((CBRASView *)GetActiveView())->m_sistema.m_camara);
	CDlgCfgImatge *cimg=&(((CBRASView *)GetActiveView())->m_sistema.m_imgconfig);
	CDspRobot *robot=&(((CBRASView *)GetActiveView())->m_sistema.m_robot);
	CPriImatge *imatge=new CPriImatge, *imatge2=new CPriImatge;
	float t1, t2;
	imatge->inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	imatge2->inicialitzar(IMG_AMPLEI_DEFECTE, IMG_ALTI_DEFECTE, cimg->m_xFinestra, cimg->m_yFinestra, cimg->m_ampleFinestra, cimg->m_altFinestra);
	if (AfxMessageBox("El procs de clcul de velocitat reconfigura l'entorn de treball, de forma que un clcul erroni conduir a un comportament inadequat de tot el sistema.\nEstau segur de que voleu continuar?", MB_OKCANCEL)!=IDOK) {
		delete imatge;
		delete imatge2;
		return;
	}
	camara->iniciarGravacio();
	AfxMessageBox("Situau un objecte al costat d'entrada de la cinta.\nEn haver-ho fet, pitjau 'Acceptar'");
	AfxMessageBox("Ara heu de fer el segent:\n(1).- Pitjar 'Acceptar' per a que la cinta es posi en moviment\n2.- Tornar a pitjar quan la pea hagi acabat d'entrar en el camp de visi.\n3.- Pitjar altre vegada acceptar quan la pea estigui per sortir del camp de visi\n4.- Pitjat de nou 'Acceptar' per a aturar la cinta");
	robot->activarCinta();
	AfxMessageBox("Ara heu de fer el segent:\n1.- Pitjar 'Acceptar' per a que la cinta es posi en moviment\n(2).- Tornar a pitjar quan la pea hagi acabat d'entrar en el camp de visi.\n3.- Pitjar altre vegada acceptar quan la pea estigui per sortir del camp de visi\n4.- Pitjat de nou 'Acceptar' per a aturar la cinta");
	camara->capturarFotograma();
	t1=(float)clock();
	camara->posarEnMemoria(imatge);
	camara->iniciarGravacio();
	AfxMessageBox("Ara heu de fer el segent:\n1.- Pitjar 'Acceptar' per a que la cinta es posi en moviment\n2.- Tornar a pitjar quan la pea hagi acabat d'entrar en el camp de visi.\n(3).- Pitjar altre vegada acceptar quan la pea estigui per sortir del camp de visi\n4.- Pitjat de nou 'Acceptar' per a aturar la cinta");
	camara->capturarFotograma();
	t2=(float)clock();
	camara->posarEnMemoria(imatge2);
	camara->iniciarGravacio();
	AfxMessageBox("Ara heu de fer el segent:\n1.- Pitjar 'Acceptar' per a que la cinta es posi en moviment\n2.- Tornar a pitjar quan la pea hagi acabat d'entrar en el camp de visi.\n3.- Pitjar altre vegada acceptar quan la pea estigui per sortir del camp de visi\n(4).- Pitjat de nou 'Acceptar' per a aturar la cinta");
	robot->desactivarCinta();
	camara->aturarGravacio();
	((CBRASView *)GetActiveView())->finalitzarObtencioVelocitat(imatge, imatge2, (float)((t2-t1)/CLOCKS_PER_SEC));
}


void CMainFrame::OnCellaCrearCriteris() 
{
	((CBRASView *)GetActiveView())->m_sistema.m_creacriteris.assignarVista(((CBRASView *)GetActiveView()));
	((CBRASView *)GetActiveView())->m_sistema.m_creacriteris.alternar();
}

void CMainFrame::OnUpdateCellaCrearCriteris(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(((CBRASView *)GetActiveView())->m_sistema.m_creacriteris.estaActiu());	
}

void CMainFrame::OnAjudaIv400() 
{
	UWORD SDKVersion=IV4InquireSDKVersion();
	char tmp[300];
	sprintf (tmp, "SDK v%x.%x", SDKVersion >> 8, SDKVersion & 0x00ff);
	AfxMessageBox(tmp);
}

void CMainFrame::OnArxiuSave() 
{
	char directoriActual[300];
	char nomArxiu[300];
	int i;
	static char BASED_CODE szFilter[] = "Arxius de mapa de bits (*.bmp)|*.bmp|Tots els Arxius (*.*)|*.*||";
	CFileDialog fdlg(false, ".dob", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	GetCurrentDirectory(200, directoriActual);
	if (fdlg.DoModal()!=IDOK) return;
	SetCurrentDirectory(directoriActual);
	for (i=0;i<fdlg.GetPathName().GetLength();i++)
		nomArxiu[i]=fdlg.GetPathName()[i];
	nomArxiu[i]=0;
	IV4BMPSave(nomArxiu, 0, 0, 640, 480, IV4_Save_As_Is); 
}
