/////////////////////////////////////////////////////////////////
//
// Arxiu      : MainFrm.h
//
// Descripci : L'aplicaci t un sol objecte de tipus CMainFrm.
//				La seva funci bsica s la de respondre als
//				events de selecci d'opcions de men.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__D36FE60C_EA07_11D3_B5CA_00C026C084F2__INCLUDED_)
#define AFX_MAINFRM_H__D36FE60C_EA07_11D3_B5CA_00C026C084F2__INCLUDED_

//
// Arxius de capalera
//
#include "PriImatge.h"
#include "AuxObjecte.h"
#include "DlgVisIdentificats.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//
// Missatges
//
#define MFR_NOEFECTE_FINS_REINICI "Els canvis que acabau de fer en la configuraci del robot no tendran efecte fins que sortiu i torneu a entrar a l'aplicaci"

class CMainFrame : public CFrameWnd
{
protected:
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnMove(int x, int y);
	afx_msg void OnCamaraIniciarGravacio();
	afx_msg void OnCamaraAturarGravacio();
	afx_msg void OnCamaraCapturarFotograma();
	afx_msg void OnUpdateCamaraIniciarGravacio(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCamaraAturarGravacio(CCmdUI* pCmdUI);
	afx_msg void OnImatgeConfigurar();
	afx_msg void OnImatgeBinaritzar();
	afx_msg void OnImatgeThreshold();
	afx_msg void OnImatgeErosionar();
	afx_msg void OnImatgeDilatar();
	afx_msg void OnImatgeProces();
	afx_msg void OnImatgePropietats();
	afx_msg void OnVeureHistograma();
	afx_msg void OnUpdateVeureHistograma(CCmdUI* pCmdUI);
	afx_msg void OnVeurePreferencies();
	afx_msg void OnUpdateImatgeConfigurar(CCmdUI* pCmdUI);
	afx_msg void OnRobotTerminal();
	afx_msg void OnUpdateRobotTerminal(CCmdUI* pCmdUI);
	afx_msg void OnRobotDownload();
	afx_msg void OnRobotConfigurar();
	afx_msg void OnCellaConfigurar();
	afx_msg void OnCellaIdentificar();
	afx_msg void OnCellaScript();
	afx_msg void OnCellaCalibrar();
	afx_msg void OnCellaEndavant();
	afx_msg void OnUpdateCellaEndavant(CCmdUI* pCmdUI);
	afx_msg void OnCellaVcinta();
	afx_msg void OnCellaCrearCriteris();
	afx_msg void OnUpdateCellaCrearCriteris(CCmdUI* pCmdUI);
	afx_msg void OnAjudaIv400();
	afx_msg void OnArxiuSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__D36FE60C_EA07_11D3_B5CA_00C026C084F2__INCLUDED_)
