/////////////////////////////////////////////////////////////////
//
// Arxiu      : PriImgMarques.cpp
//
// Descripci : CPriImgMarques s una classe derivada de CPriImg.
//				Els objectes d'aquesta classe estan pensats per
//				a contenir el resultat de l'anlisi de connecti-
//				vitat generats per CPriImatge.
//				La seva funci s inicialitzar 'n' objectes de
//				la classe CPriRegio, a on 'n' s el nmero
//				d'objectes diferents presents en l'objecte de
//				classe CPriImgMarques, i  on cada objecte
//				CPriRegio contedr un i sols un dels objectes
//				(grfics) en qesti.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

//
// Arxius de capalera
//
#include "stdafx.h"
#include "BRAS.h"
#include "PriImgMarques.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CPriImgMarques::CPriImgMarques()
{
}

CPriImgMarques::~CPriImgMarques()
{

}

int CPriImgMarques::obtenirNumMarques()
{
	return m_numMarques+1;
}

void CPriImgMarques::posarNumMarques(int n)
{
	m_numMarques=n;
}

CPriImgMarques & CPriImgMarques::operator =(const CPriImgMarques & laImg)
{
	CPriImg::operator=(laImg);
	m_numMarques=laImg.m_numMarques;
	return *this;
}

void CPriImgMarques::inicialitzar(int ample, int alt, int xf, int yf, int amplef, int altf)
{
	CPriImg::inicialitzar(ample, alt, xf, yf, amplef, altf);
	m_numMarques=0;
}

void CPriImgMarques::crearRegio(int n, CPriRegio * r)
{
	int x, y;
	TPixel **laMatriuRegio=r->obtenirMatriu();

	normalitzarFinestra();
	if (r->obtenirAmpleImatge()!=m_ampleImatge || r->obtenirAltImatge()!=m_altImatge) {
		m_error=IMG_TAMANY_REGIO_INCORRECTE;
		return;
	}

	r->posarXFinestra(m_xFinestra);
	r->posarYFinestra(m_yFinestra);
	r->posarAmpleFinestra(m_ampleFinestra);
	r->posarAltFinestra(m_altFinestra);

	for (y=0;y<m_altImatge;y++)
		for (x=0;x<m_ampleImatge;x++)
			if (laMatriu[y][x]==n) laMatriuRegio[y][x]=IMG_OBJECTE;
			else laMatriuRegio[y][x]=IMG_FONS;
}
