/////////////////////////////////////////////////////////////////
//
// Arxiu      : PriRegio.h
//
// Descripci : Els objectes d'aquest tipus estan pensats
//				per a rebre informaci d'un sol objecte (grfic)
//				des d'un objecte de tipus CPriImgMarques.
//				La classe CPriRegio proporciona mtodes per
//				a obtenir les propietats de l'objecte grfic
//				(rea, permetre, ...)
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_REGIO_H__F84CB252_EE06_11D3_B5CF_00C026C084F2__INCLUDED_)
#define AFX_REGIO_H__F84CB252_EE06_11D3_B5CF_00C026C084F2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//
// Arxius de capalera
//
#include "PriImg.h"

class CPriRegio : public CPriImg  
{
public:
	double obtenirOrientacio();
	void obtenirDMax(int *x, int *y, int *d);
	void obtenirDMin(int *x, int *y, int *d);
	double obtenirCompacitat();
	int obtenirPerimetre(CPriImg *img);
	TPixel ** obtenirMatriu();
	void obtenirCentreGravetat(int *xc, int *yc);
	long obtenirArea();
	void inicialitzar(int ample=IMG_AMPLEI_DEFECTE, int alt=IMG_ALTI_DEFECTE, int xf=IMG_XF_DEFECTE, int yf=IMG_YF_DEFECTE, int amplef=IMG_AMPLEF_DEFECTE, int altf=IMG_ALTF_DEFECTE);
	CPriRegio();
	virtual ~CPriRegio();

private:
	double m_orientacio;
	bool m_orientacioCalculada;
	void calcularOrientacio();
	double distancia (double x1, double y1, double x2, double y2);
	void calcularDMinDMax();
	CPriImg m_contorn;
	void calcularPerimetre();
	bool m_perimetreCalculat;
	int m_perimetre;
	void calcularCentreGravetat();
	bool m_centreCalculat;
	int m_yCentre;
	int m_xCentre;
	void calcularArea();
	long m_area;
	bool m_areaCalculada;
	int m_xDMin;
	int m_xDMax;
	int m_yDMin;
	int m_yDMax;
	int m_dMin;
	int m_dMax;
	bool m_distanciesCalculades;
};

#endif // !defined(AFX_REGIO_H__F84CB252_EE06_11D3_B5CF_00C026C084F2__INCLUDED_)
