/////////////////////////////////////////////////////////////////
//
// Arxiu      : ScrIdentificacio.h
//
// Descripci : Aquesta classe permet classificar un objecte
//				en funci de les propietats que t.
//				A ms, un objecte d'aquesta classe pot carregar
//				i guardar arxius .dob.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_IDENTIFICACIO_H__869C13A3_EF84_11D3_B5D5_00C026C084F2__INCLUDED_)
#define AFX_IDENTIFICACIO_H__869C13A3_EF84_11D3_B5D5_00C026C084F2__INCLUDED_

//
// Arxius de capalera
//
#include "AuxToken.h"
#include "AuxObjecte.h"
#include "AuxCriteri.h"	

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//
// Missatges pels possibles errors en la lectura de l'arxiu amb
// definicions d'objectes
//

#define IDE_ERROR_OBRIRCLAU				"S'esperava el caracter d'obertura de bloc ({)"
#define IDE_ERROR_NOUOBJECTE_O_FIARXIU	"S'esperava el nom d'un nou objecte"
#define IDE_ERROR_CRITERIS				"S'esperava la paraula clau d'inici de definici de criteris (CRITERIS)"
#define IDE_ERROR_CRITERIS_O_AGAFADA	"S'esperava la paraula clau d'inici de definici de criteris (CRITERIS) o d'inici de definici de forma d'agafada (AGAFADA)"
#define IDE_ERROR_PUNTICOMA				"S'esperava el caracter de fi d'instruccio (;)"
#define IDE_ERROR_VALORNUMERIC			"S'esperava un valor numeric distint de zero"
#define IDE_ERROR_DESPROT_O_TANCARCLAU	"S'esperava alguna de les segents paraules clau: DX, DY, R o '}'"
#define IDE_ERROR_COMPARADOR			"S'esperava un operador de comparaci (<, >, <=, >=, == o !=)"
#define IDE_ERROR_ATRIBUT_O_TANCARCLAU	"S'esperava un atribut (AREA, PERIMETRE, DMIN, DMAX o COMPACITAT) o el smbol de tancament de bloc ('}')"
#define IDE_ERROR_OPERACIO_O_PUNTICOMA	"S'esperava un operador numric (+, -, * o /) o el smbol de fi d'instrucci (';')"
#define IDE_ERROR_ATRIBUT_O_VALORNUMERIC "S'esperava un atribut (AREA, PERIMETRE, DMIN, DMAX o COMPACITAT) o un valor numeric distint de zero"

class CScrIdentificacio  
{
public:
	CAuxObjecte * identificarObjecte(long elArea, int elPerimetre, int laDMin, int laDMax, double laCompacitat);
	void guardarObjectes(CString nomArxiu);
	void borrarObjectes();
	CLlistaObjectes m_objectes;
	void inicialitzar(void *sistema);
	// Si cridam carregarObjectes just desprs d'inicialitzar, carrega
	// els objectes. Si es crida carregarObjectes varies vegades seguides
	// per a distints arxius (o el mateix...), afegeix els nous objectes
	// al final de la llista.
	void carregarObjectes(CString nomArxiu);
	CScrIdentificacio();
	virtual ~CScrIdentificacio();

private:
	bool avaluarComparacio(enum TAtribut elAtribut, enum TComparacio elComparador, double elValor, long elArea, int elPerimetre, int laDMin, int laDMax, double laCompacitat);
	double avaluarExpressio(CLlistaElementsExpressio *le, long elArea, int elPerimetre, int laDMin, int laDMax, double laCompacitat);
	CString obtenirCadena(enum TToken tk);
	CAuxElementExpressio * m_elementExpressioActual;
	CAuxCriteri *m_criteriActual;
	CAuxObjecte *m_objecteActual;
	int m_columnaError;
	int m_liniaError;
	int m_numLiniaActual;
	void posarErrorParsing(CString elError);
	void parseVALOR();
	void parseEXPRESSIO2();
	void parseEXPRESSIO();
	void parseCRITERIS();
	void parseAGAFADA();
	void parseOBJECTE();
	void parseLLISTAOBJECTES();
	bool m_errorParsejant;
	CString m_textError;
	CAuxToken m_tokenActual;
	CLlistaTokens m_tokens;
	int m_posicioActual;
	CString m_liniaActual;
	void obtenirToken(CAuxToken *elToken);
	CArchive * m_arxiu;
	CFile * m_fitxer;
	CString m_nomArxiu;
};

#endif // !defined(AFX_IDENTIFICACIO_H__869C13A3_EF84_11D3_B5D5_00C026C084F2__INCLUDED_)
