/////////////////////////////////////////////////////////////////
//
// Arxiu      : Sistema.h
//
// Descripci : Es el cor de l'aplicaci. Cont tots els objectes 
//              que han d'esser persistents al llarg de l'execuci
//				del programa. Tamb s'encarrega d'inicialitzar-los
//				tots, cosa que fa dins del seu constructor, i de 
//				finalitzar-los, cosa que fa en el destructor.
//				A ms, s'encarrega de realitzar aquelles funcions 
//				d'interacci entre objectes que no tenen cabuda 
//				en cap de les parts implicades. Com ara, la 
//				conversi de sistema de coordenades pantalla a 
//				sistema de coordenades robot.
//
// Autor      : Antoni Burguera i Burguera
//
/////////////////////////////////////////////////////////////////

#if !defined(AFX_SISTEMA_H__869C13A2_EF84_11D3_B5D5_00C026C084F2__INCLUDED_)
#define AFX_SISTEMA_H__869C13A2_EF84_11D3_B5D5_00C026C084F2__INCLUDED_

//
// Arxius de capalera
//
#include "DspCamara.h"
#include "DspRobot.h"
#include "ScrIdentificacio.h"
#include "DlgCfgImatge.h"
#include "DlgVisHistograma.h"
#include "DlgCfgGeneral.h"
#include "DlgTerminalRobot.h"
#include "DlgCfgRobot.h"
#include "DlgCfgCella.h"
#include "ScrInterpret.h"
#include "PriAnalisiMoviment.h"
#include "DlgCfgCriteris.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define SIS_DIST_APROXIMACIO 600

class CSistema  
{
public:
	void realitzarProcesImatge(CPriImatge *imatge);
	CString m_arxiuConfiguracioImatge;
	CString m_arxiuConfiguracioGeneral;
	CString m_arxiuConfiguracioRobot;
	CString m_arxiuConfiguracioCella;
	CString m_arxiuConfiguracioCriteris;
	CDlgCfgCriteris m_creacriteris;
	void calcularAgafada(CAuxObjecte *obj, int *xc, int *yc, double *orien, int xmn, int ymn);
	CPriAnalisiMoviment m_analisi;
	CScrInterpret m_interpret;
	CDlgCfgCella m_cellconfig;
	CDlgCfgRobot m_robconfig;
	CDlgTerminalRobot m_terminal;
	CDlgCfgGeneral m_genconfig;
	CDlgVisHistograma m_histograma;
	void pantallaARobot(int *x, int *y, double *o);
	CScrIdentificacio m_identificacio;
	CDspRobot m_robot;
	CDspCamara m_camara;
	CDlgCfgImatge m_imgconfig;
	CSistema();
	virtual ~CSistema();
private:
	CPoint traslladar(CPoint punt, int dx, int dy);
	CPoint rotar(CPoint punt, double angle);
	int m_zrAgafada;
	int m_zrAproximacio;
};

#endif // !defined(AFX_SISTEMA_H__869C13A2_EF84_11D3_B5D5_00C026C084F2__INCLUDED_)
